package Util;

import android.content.Context;
import android.location.Address;
import android.location.Geocoder;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;

import java.io.IOException;
import java.util.List;
import java.util.Locale;

/**
 * Created by kleber.silva.araujo on 13/09/2015.
 */
public class LocationAddress {

    private static final String TAG = "LocationAddress";

    public static void getAddressFromLocation(final double latitude, final double longitude,
                                              final Context context, final Handler handler) {
        Thread thread = new Thread() {
            @Override
            public void run() {

                Geocoder geocoder = new Geocoder(context, Locale.getDefault());
                String city    = null;
                String state   = null;
                String country = null;
                boolean result = false;

                try {

                    List<Address> addressList = geocoder.getFromLocation(latitude, longitude, 1);

                    if (addressList != null && addressList.size() > 0) {

                        result = true;

                        Address address = addressList.get(0);

                        city    = address.getSubAdminArea();
                        if ( city == null || city.isEmpty() )
                            city    = address.getLocality();

                        state   = address.getAdminArea();
                        country = address.getCountryName();

                    }
                }
                catch (IOException e) {
                    Log.e(TAG, "Unable connect to Geocoder", e);
                }
                finally {

                    Message message = Message.obtain();
                    message.setTarget(handler);

                    if (result) {
                        message.what = 10;
                        Bundle bundle = new Bundle();
                        bundle.putString("city", city);
                        bundle.putString("state", state);
                        bundle.putString("country", country);
                        message.setData(bundle);
                    } else {
                        message.what = 11;
                        Bundle bundle = new Bundle();
                        String s = "Latitude: " + latitude + " Longitude: " + longitude +
                                "\n Unable to get address for this lat-long.";
                        bundle.putString("address", s);
                        message.setData(bundle);
                    }
                    message.sendToTarget();
                }
            }
        };
        thread.start();
    }
}