package Util;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Intent;
import android.os.AsyncTask;
import android.util.Base64;
import android.widget.Toast;

import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpDelete;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.params.BasicHttpParams;
import org.apache.http.protocol.HTTP;
import org.json.JSONArray;
import org.json.JSONObject;

import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.List;

import tads.ufpr.pr.br.backstage.AppController;
import tads.ufpr.pr.br.backstage.Instrumento;
import tads.ufpr.pr.br.backstage.ProfileActivity;
import tads.ufpr.pr.br.backstage.R;
import tads.ufpr.pr.br.backstage.Usuario;

import static org.apache.http.params.HttpConnectionParams.setConnectionTimeout;
import static org.apache.http.params.HttpConnectionParams.setSoTimeout;

public class UpdateInstruments extends AsyncTask<Void, Void, Void> {

    Usuario u;
    Activity activity;
    HttpResponse response;
    ProgressDialog progressDialog;

    public UpdateInstruments(Usuario u, Activity activity){
        this.activity = activity;
        this.u = u;
    }

    @Override
    protected void onPreExecute() {
        super.onPreExecute();

        progressDialog = new ProgressDialog(activity, R.style.AppTheme_Dark_Dialog);
        progressDialog.setIndeterminate(true);
        progressDialog.setCancelable(false);
        progressDialog.setMessage(activity.getResources().getString(R.string.updating));
        progressDialog.show();

    }

    @Override
    protected void onPostExecute(Void aVoid) {
        super.onPostExecute(aVoid);

        progressDialog.dismiss();
        progressDialog.cancel();

        if ( response != null && ( response.getStatusLine().getStatusCode() == 201 ||
                response.getStatusLine().getStatusCode() == 204 ) ) {

            ((AppController) activity.getApplication()).setUsuario(u);
            DatabaseHandler db = new DatabaseHandler(activity);
            db.addInstrument(u);

            ((AppController)activity.getApplication()).setUpdated(true);
            Intent i = new Intent(activity, ProfileActivity.class);
            activity.startActivity(i);
            activity.finish();
            activity.overridePendingTransition(R.animator.mainfadein, R.animator.splashfadeout);

        }
        else
            Toast.makeText(activity, activity.getResources()
                    .getString(R.string.update_profile_error), Toast.LENGTH_SHORT).show();
    }


    @Override
    protected Void doInBackground(Void... params) {

        try{

            BasicHttpParams httpParams = new BasicHttpParams();
            setConnectionTimeout(httpParams, 3000);
            setSoTimeout(httpParams, 10000);
            HttpClient httpclient = new DefaultHttpClient(httpParams);

            String url = activity.getString(R.string.server_address)
                    + "/usuario/" + u.getId() + "/instrumentos";

            if ( u.getInstrumentos() != null && !u.getInstrumentos().isEmpty() ){

                HttpPost httpPost = new HttpPost(url);

                String user = activity.getString(R.string.server_user);
                String basicAuth = "Basic " + Base64.encodeToString(user.getBytes(), Base64.NO_WRAP);
                httpPost.setHeader("Authorization", basicAuth);

                List<NameValuePair> lp = new ArrayList<>();
                JSONArray ja = new JSONArray();

                for ( Instrumento i : u.getInstrumentos() ){
                    JSONObject jo = new JSONObject();
                    jo.put("id", i.getInstId());
                    jo.put("nivel", i.getInstLevel());
                    ja.put(jo);
                }

                JSONObject jo = new JSONObject();
                jo.put("instrumentos", ja);

                httpPost.setHeader("Accept", "application/json");
                httpPost.setHeader("Content-type", "application/json");

                StringEntity se = new StringEntity(jo.toString(), HTTP.UTF_8);
                httpPost.setEntity(se);
                response = httpclient.execute(httpPost);

            }
            else{

                HttpDelete httpDel = new HttpDelete(url);
                response = httpclient.execute(httpDel);

            }
        }
        catch (UnsupportedEncodingException e) { e.printStackTrace(); }
        catch (Exception e) { e.printStackTrace(); }

        return null;
    }
}
