package Util;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Intent;
import android.os.AsyncTask;
import android.util.Base64;
import android.widget.Toast;
import org.apache.http.HttpResponse;
import org.apache.http.HttpVersion;
import org.apache.http.NameValuePair;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPut;
import org.apache.http.conn.ClientConnectionManager;
import org.apache.http.conn.scheme.PlainSocketFactory;
import org.apache.http.conn.scheme.Scheme;
import org.apache.http.conn.scheme.SchemeRegistry;
import org.apache.http.conn.ssl.SSLSocketFactory;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.impl.conn.tsccm.ThreadSafeClientConnManager;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.params.BasicHttpParams;
import org.apache.http.params.HttpProtocolParams;
import org.apache.http.protocol.HTTP;
import java.io.UnsupportedEncodingException;
import java.security.KeyStore;
import java.util.ArrayList;
import java.util.List;
import tads.ufpr.pr.br.backstage.AppController;
import tads.ufpr.pr.br.backstage.ProfileActivity;
import tads.ufpr.pr.br.backstage.R;
import tads.ufpr.pr.br.backstage.Usuario;

import static org.apache.http.params.HttpConnectionParams.setConnectionTimeout;
import static org.apache.http.params.HttpConnectionParams.setSoTimeout;

@SuppressWarnings("All")
public class UpdateProfile extends AsyncTask<Void, Void, Void> {

    Usuario u;
    Activity activity;
    HttpResponse response;
    ProgressDialog progressDialog;

    public UpdateProfile(Usuario u, Activity activity){
        this.activity = activity;
        this.u = u;
    }

    @Override
    protected void onPreExecute() {
        super.onPreExecute();

        progressDialog = new ProgressDialog(activity, R.style.AppTheme_Dark_Dialog);
        progressDialog.setIndeterminate(true);
        progressDialog.setCancelable(false);
        progressDialog.setMessage(activity.getResources().getString(R.string.updating));
        progressDialog.show();

    }

    @Override
    protected void onPostExecute(Void aVoid) {
        super.onPostExecute(aVoid);

        progressDialog.dismiss();
        progressDialog.cancel();

        if ( response != null && response.getStatusLine().getStatusCode() == 200 ) {

            ((AppController) activity.getApplication()).setUsuario(u);

            DatabaseHandler db = new DatabaseHandler(activity);
            db.updateUser(u);

            ((AppController)activity.getApplication()).setUpdated(true);
            Intent i = new Intent(activity, ProfileActivity.class);
            activity.startActivity(i);
            activity.finish();
            activity.overridePendingTransition(R.animator.mainfadein, R.animator.splashfadeout);
        }
        else{

            Toast.makeText(activity, activity.getResources()
                    .getString(R.string.update_profile_error), Toast.LENGTH_SHORT).show();

        }
    }

    @Override
    protected Void doInBackground(Void... params) {

        try{

            KeyStore trustStore = KeyStore.getInstance(KeyStore.getDefaultType());
            trustStore.load(null, null);

            MySSLSocketFactory sf = new MySSLSocketFactory(trustStore);
            sf.setHostnameVerifier(SSLSocketFactory.ALLOW_ALL_HOSTNAME_VERIFIER);

            BasicHttpParams httpParams = new BasicHttpParams();
            setConnectionTimeout(httpParams, 3000);
            setSoTimeout(httpParams, 5000);

            HttpProtocolParams.setVersion(httpParams, HttpVersion.HTTP_1_1);
            HttpProtocolParams.setContentCharset(httpParams, HTTP.UTF_8);

            SchemeRegistry registry = new SchemeRegistry();
            registry.register(new Scheme("http", PlainSocketFactory.getSocketFactory(), 80));
            registry.register(new Scheme("https", sf, 443));

            ClientConnectionManager ccm = new ThreadSafeClientConnManager(httpParams, registry);

            HttpClient httpclient = new DefaultHttpClient(ccm, httpParams);

            httpclient = new DefaultHttpClient(httpParams);

            String url = activity.getString(R.string.server_address) + "/usuario";

            HttpPut httpPut = new HttpPut(url);

            String user = activity.getString(R.string.server_user);
            String basicAuth = "Basic " + Base64.encodeToString(user.getBytes(), Base64.NO_WRAP);
            httpPut.setHeader("Authorization", basicAuth);

            String estilos = "", influencias = "";

            if ( u.getEstilos() != null && !u.getEstilos().isEmpty() ){
                for ( String s : u.getEstilos() ){
                    estilos = estilos + s + ",";
                }
            }

            if ( u.getInfluencias() != null && !u.getInfluencias().isEmpty() ){
                for ( String s : u.getInfluencias() ){
                    influencias = influencias + s + ",";
                }
            }

            List<NameValuePair> lp = new ArrayList<>();
            lp.add(new BasicNameValuePair("mail",     u.getEmail()));
            lp.add(new BasicNameValuePair("name",     u.getNome()));
            lp.add(new BasicNameValuePair("image",    u.getImagem()));
            lp.add(new BasicNameValuePair("birth",    u.getDtNasc()));
            lp.add(new BasicNameValuePair("style",    estilos));
            lp.add(new BasicNameValuePair("influ",    influencias));
            lp.add(new BasicNameValuePair("about",    u.getSobre()));
            lp.add(new BasicNameValuePair("lat" ,     String.valueOf(u.getLatitude())));
            lp.add(new BasicNameValuePair("long",     String.valueOf(u.getLongitude())));
            lp.add(new BasicNameValuePair("city",     u.getCidade()));
            lp.add(new BasicNameValuePair("state",    u.getEstado()));
            lp.add(new BasicNameValuePair("country",  u.getPais()));

            UrlEncodedFormEntity urle = new UrlEncodedFormEntity(lp, HTTP.UTF_8);
            urle.setContentType("application/x-www-form-urlencoded");
            urle.setContentEncoding(HTTP.UTF_8);

            httpPut.setHeader(HTTP.CONTENT_TYPE, "application/x-www-form-urlencoded; charset=UTF-8");
            httpPut.setEntity(urle);
            response = httpclient.execute(httpPut);

            httpPut.abort();
            httpclient.getConnectionManager().closeExpiredConnections();
            httpclient.getConnectionManager().shutdown();

        }
        catch (UnsupportedEncodingException e) { e.printStackTrace(); }
        catch (Exception e) { e.printStackTrace(); }

        return null;
    }
}
