package tads.ufpr.pr.br.backstage;

import android.app.AlertDialog;
import android.app.Fragment;
import android.content.Context;
import android.content.DialogInterface;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.Spinner;
import android.widget.TextView;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

public class EditInstrumentosFragment extends Fragment {

    Usuario p;
    Usuario u;
    ListView lv;
    AdapterListView alv;

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {

        View v = inflater.inflate(R.layout.edit_instrumentos_fragment, container, false);
        lv = (ListView) v.findViewById(R.id.list_inst_edit);
        setHasOptionsMenu(true);

        p = ((AppController) v.getContext().getApplicationContext()).getUsuario();
        u = ((AppController) v.getContext().getApplicationContext()).getUsuario();

        if (p.getInstrumentos() != null && !p.getInstrumentos().isEmpty()) {
            alv = new AdapterListView(getActivity(), p.getInstrumentos());
            lv.setAdapter(alv);
        }

        lv.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, final int position, long id) {

                AlertDialog.Builder adbuilder = new AlertDialog.Builder(getActivity());
                adbuilder.setItems(R.array.edit_remove_array, new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int which) {

                        if (which == 0) {

                            HashMap map = new HashMap();
                            map.put("type", p.getInstrumentos().get(position).getInstType());
                            map.put("inst", p.getInstrumentos().get(position).getInstId());
                            map.put("level", p.getInstrumentos().get(position).getInstLevel());
                            map.put("position", position);

                            showInstPopUp(map);

                        } else {
                            p.getInstrumentos().remove(position);
                            ((AppController) getActivity().getApplication()).setUsuario(p);
                            alv.notifyDataSetChanged();
                        }
                    }
                });
                adbuilder.show();
            }
        });

        return v;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {

        if (item.getItemId() == R.id.menu_add_instrument)
            showInstPopUp(null);

        return super.onOptionsItemSelected(item);
    }

    private void showInstPopUp(final HashMap map) {

        LayoutInflater li = (LayoutInflater) getActivity().getSystemService(Context.LAYOUT_INFLATER_SERVICE);

        final View v = li.inflate(R.layout.add_instrument_dialog, null);
        AlertDialog.Builder adb = new AlertDialog.Builder(li.getContext());
        adb.setView(v);
        adb.setTitle(getString(R.string.add_inst));

        final List<InstType> linstType = ((AppController) getActivity().getApplication()).getListInstType();

        final Spinner instTypeSpinner = (Spinner) v.findViewById(R.id.instType_spinner);
        final Spinner instument = (Spinner) v.findViewById(R.id.instrument_spinner);
        final Spinner level = (Spinner) v.findViewById(R.id.level_spinner);

        List<String> list = new ArrayList<>();
        if (map == null)
            for (Instrumento i : linstType.get(0).getInstrumentos()) {
                String s = i.getInstName();
                list.add(s);
            }
        else
            for ( Instrumento i : linstType.get(Integer.parseInt(map.get("type").toString()) - 1).getInstrumentos() ) {
                String s = i.getInstName();
                list.add(s);
            }

        ArrayAdapter<String> spinnerArrayAdapter = new ArrayAdapter<>(getActivity(), android.R.layout.simple_spinner_item, list);
        spinnerArrayAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        instument.setAdapter(spinnerArrayAdapter);

        final ArrayAdapter<CharSequence> adapter = ArrayAdapter.createFromResource(getActivity(),
                R.array.level_array, android.R.layout.simple_spinner_item);

        adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        level.setAdapter(adapter);

        final InstTypeSpinnerAdapter itsa = new InstTypeSpinnerAdapter(getActivity(), R.id.rl_spinner_instType, R.id.tv_instTypeName, linstType);

        instTypeSpinner.setAdapter(itsa);
        instTypeSpinner.setOnItemSelectedListener(
                new AdapterView.OnItemSelectedListener() {

                    @Override
                    public void onItemSelected(AdapterView<?> parentView, View selectedItemView, int position, long id) {

                        int x = 0, instId = 0;
                        List<String> list = new ArrayList<>();
                        for (Instrumento i : linstType.get(position).getInstrumentos()) {

                            String s = i.getInstName();
                            list.add(s);

                            if (map != null)
                                if (Integer.parseInt(map.get("inst").toString()) == i.getInstId())
                                    instId = x;

                            x++;
                        }

                        ArrayAdapter<String> spinnerArrayAdapter = new ArrayAdapter<>(getActivity(), android.R.layout.simple_spinner_item, list);
                        spinnerArrayAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
                        instument.setAdapter(spinnerArrayAdapter);
                        if (map != null) {
                            instument.setSelection(instId);
                        }

                    }

                    @Override
                    public void onNothingSelected(AdapterView<?> parentView) {
                        // Do nothing
                    }
                }

        );

        adb.setNegativeButton(

                getString(R.string.cancel),

                new DialogInterface.OnClickListener()

                {
                    public void onClick(DialogInterface dialog, int which) {
                        dialog.cancel();
                    }
                }

        );

        adb.setPositiveButton(

                getString(R.string.save),

                new DialogInterface.OnClickListener()

                {
                    public void onClick(DialogInterface dialog, int which) {
                        dialog.cancel();

                        int instType = ((Spinner) v.findViewById(R.id.instType_spinner)).getSelectedItemPosition();
                        int inst = ((Spinner) v.findViewById(R.id.instrument_spinner)).getSelectedItemPosition();
                        int level = ((Spinner) v.findViewById(R.id.level_spinner)).getSelectedItemPosition();

                        Instrumento i = new Instrumento();
                        i.setInstType(linstType.get(instType).getTypeId());
                        i.setInstLevel(level);

                        Instrumento j = linstType.get(instType).getInstrumentos().get(inst);
                        i.setInstId(j.getInstId());
                        i.setInstName(j.getInstName());

                        if (map != null) {

                            int position = Integer.parseInt(map.get("position").toString());
                            p.getInstrumentos().remove(position);
                            p.getInstrumentos().add(i);
                            alv.notifyDataSetChanged();

                        } else {

                            if (p.getInstrumentos() == null || p.getInstrumentos().isEmpty()) {

                                List<Instrumento> li = new ArrayList<>();
                                li.add(i);
                                p.setInstrumentos(li);
                                alv = new AdapterListView(getActivity(), p.getInstrumentos());
                                lv.setAdapter(alv);

                            } else {
                                p.getInstrumentos().add(i);
                                alv.notifyDataSetChanged();
                            }
                        }

                        ((AppController) getActivity().getApplication()).setUsuario(p);
                    }
                }

        );

        if (map != null)

        {
            instTypeSpinner.setSelection(Integer.parseInt(map.get("type").toString()) - 1);
            level.setSelection(Integer.parseInt(map.get("level").toString()));
            //instument.setSelection( Integer.parseInt(map.get("inst").toString())-1 );

            int x = 0, instId = 0;

            for (Instrumento i : linstType.get(Integer.parseInt(map.get("type").toString()) - 1).getInstrumentos()) {

                String s = i.getInstName();
                list.add(s);

                if (map != null)
                    if (Integer.parseInt(map.get("inst").toString()) == i.getInstId()) {
                        instId = x;
                        break;
                    }

                x++;
            }

            instument.setSelection(instId);

        }

        AlertDialog ad = adb.create();
        ad.show();

    }

    public class AdapterListView extends BaseAdapter {

        private LayoutInflater mInflater;
        private List<Instrumento> itens;

        public AdapterListView(Context context, List<Instrumento> itens) {
            this.itens = itens;
            mInflater = LayoutInflater.from(context);
        }

        public void add(Instrumento item) {
            itens.add(item);
            notifyDataSetChanged();
        }

        @Override
        public int getCount() {
            return itens.size();
        }

        @Override
        public Object getItem(int position) {
            return itens.get(position);
        }

        @Override
        public long getItemId(int position) {
            return position;
        }

        @Override
        public View getView(int position, View convertView, ViewGroup parent) {

            ItemSuporte itemHolder;
            List<InstType> linstType = ((AppController) getActivity().getApplication()).getListInstType();

            if (convertView == null) {

                convertView = mInflater.inflate(R.layout.inst_list_item, null);
                itemHolder = new ItemSuporte();
                itemHolder.iv_InstType = ((ImageView) convertView.findViewById(R.id.iv_insttype_logo));
                itemHolder.tv_InstName = ((TextView) convertView.findViewById(R.id.tv_instName));
                itemHolder.tv_InstLevel = ((TextView) convertView.findViewById(R.id.tv_instLevel));
                convertView.setTag(itemHolder);

            } else {
                itemHolder = (ItemSuporte) convertView.getTag();
            }

            Instrumento item = itens.get(position);
            String[] array = getResources().getStringArray(R.array.level_array);

            switch (item.getInstType()) {

                case 1: //Cordas

                    itemHolder.iv_InstType.setImageResource(R.drawable.chords);
                    break;

                case 2: //Percussão

                    itemHolder.iv_InstType.setImageResource(R.drawable.drums);
                    break;

                case 3: //Sopro

                    itemHolder.iv_InstType.setImageResource(R.drawable.sax);
                    break;

                case 4: //Teclas

                    itemHolder.iv_InstType.setImageResource(R.drawable.teclado);
                    break;

                case 5: //Vocal

                    itemHolder.iv_InstType.setImageResource(R.drawable.mic);
                    break;

            }

            CharSequence cs = "";
            for (Instrumento i : linstType.get(item.getInstType() - 1).getInstrumentos()) {
                if (i.getInstId() == item.getInstId()) {
                    cs = i.getInstName();
                    break;
                }
            }

            itemHolder.tv_InstName.setText(cs);
            itemHolder.tv_InstLevel.setText(array[item.getInstLevel()]);

            return convertView;
        }

        @Override
        public void notifyDataSetChanged() {
            super.notifyDataSetChanged();
        }

        private class ItemSuporte {
            ImageView iv_InstType;
            TextView tv_InstName;
            TextView tv_InstLevel;
        }
    }
}