package tads.ufpr.pr.br.backstage;

import android.app.AlertDialog;
import android.app.Fragment;
import android.content.Context;
import android.content.DialogInterface;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.inputmethod.InputMethodManager;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ListView;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import butterknife.ButterKnife;
import butterknife.InjectView;

public class EditPreferenciasFragment extends Fragment {

    @InjectView(R.id.add)       ImageButton _btnAdd;
    @InjectView(R.id.input)     EditText    _inputText;
    @InjectView(R.id.pref_list) ListView    _listView;

    View v;
    Usuario usuario;
    ArrayAdapter<String> adapter;

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        v = inflater.inflate(R.layout.edit_preferencias_fragment, container, false);

        ButterKnife.inject(this, v);

        usuario = ((AppController)getActivity().getApplication()).getUsuario();

        Bundle extras = getActivity().getIntent().getExtras();
        final String s = extras.getString("preference");

        if (s.equals(getString(R.string.style))){
            if (usuario.getEstilos() == null){
                List<String> l = new ArrayList<>();
                usuario.setEstilos(l);
            }
            adapter = new ArrayAdapter<>(getActivity(), android.R.layout.simple_list_item_1, usuario.getEstilos());
        }
        else{
            if ( usuario.getInfluencias() == null){
                List<String> l = new ArrayList<>();
                usuario.setInfluencias(l);
            }
            adapter = new ArrayAdapter<>(getActivity(), android.R.layout.simple_list_item_1, usuario.getInfluencias());
        }

        _listView.setAdapter(adapter);
        _listView.setOnItemClickListener(new AdapterView.OnItemClickListener() {

            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {

                final int pos = position;

                InputMethodManager imm = (InputMethodManager) getActivity().getSystemService(Context.INPUT_METHOD_SERVICE);
                imm.hideSoftInputFromWindow(view.getWindowToken(), 0);

                AlertDialog.Builder adbuilder = new AlertDialog.Builder(getActivity());
                adbuilder.setTitle(getString(R.string.remove_pref_title));
                adbuilder.setMessage(getString(R.string.remove_inst_text) + " " +
                        (_listView.getItemAtPosition(position)) + " " + getString(R.string.remove_pref_text2));
                adbuilder.setNegativeButton(getString(R.string.cancel), new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int which) {
                        dialog.cancel();
                    }
                });

                adbuilder.setPositiveButton(getString(R.string.remove), new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int which) {
                        dialog.cancel();
                        if (s.equals(getString(R.string.style))) {
                            usuario.getEstilos().remove(pos);
                        } else {
                            usuario.getInfluencias().remove(pos);
                        }
                        ((AppController) getActivity().getApplication()).setUsuario(usuario);
                        adapter.notifyDataSetChanged();
                    }
                });
                adbuilder.show();
            }
        });

        _btnAdd.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                String text = _inputText.getText().toString();

                if ( text.isEmpty()) {
                    _inputText.setError(getString(R.string.add_pref_error));
                }
                else {

                    _inputText.setText("");
                    InputMethodManager imm = (InputMethodManager)getActivity().getSystemService(Context.INPUT_METHOD_SERVICE);
                    imm.hideSoftInputFromWindow(v.getWindowToken(), 0);

                    if (s.equals(getString(R.string.style))) {
                        usuario.getEstilos().add(text);
                        Collections.sort(usuario.getEstilos());
                    } else {
                        usuario.getInfluencias().add(text);
                        Collections.sort(usuario.getInfluencias());
                    }

                    ((AppController) getActivity().getApplication()).setUsuario(usuario);
                    adapter.notifyDataSetChanged();
                }
            }
        });

        return v;
    }
}