package tads.ufpr.pr.br.backstage;

import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;

public abstract class EndlessRecyclerOnScrollListener extends RecyclerView.OnScrollListener {

    public static String TAG = EndlessRecyclerOnScrollListener.class.getSimpleName();

    private boolean loading = true;
    private int totalAnterior = 0;
    private int minVisivel = 4;
    int primeiroVisivel, qtdVisivel, total;
    private LinearLayoutManager mLinearLayoutManager;
    private int offset = 1;

    public EndlessRecyclerOnScrollListener(LinearLayoutManager linearLayoutManager) {
        this.mLinearLayoutManager = linearLayoutManager;
    }

    @Override
    public void onScrolled(RecyclerView recyclerView, int dx, int dy) {
        super.onScrolled(recyclerView, dx, dy);

        total = recyclerView.getAdapter().getItemCount();
        qtdVisivel = recyclerView.getChildCount();
        primeiroVisivel = mLinearLayoutManager.findFirstVisibleItemPosition();

        if ( loading ){
            if ( total > totalAnterior ) {
                loading = false;
                totalAnterior = total;
            }
        }
        if ( !loading && ( totalAnterior - qtdVisivel ) <= ( primeiroVisivel + minVisivel )){
            offset++;
            onLoadMore(offset);
            loading = true;
        }
    }

    public abstract void onLoadMore(int offset);

    public void reset(int previousTotal, boolean loading) {
        this.totalAnterior = previousTotal;
        this.loading = loading;
    }
}
