package tads.ufpr.pr.br.backstage;

import android.app.NotificationManager;
import android.app.Service;
import android.content.Intent;
import android.media.RingtoneManager;
import android.os.AsyncTask;
import android.os.Handler;
import android.os.IBinder;
import android.support.v4.app.NotificationCompat;
import android.util.Base64;

import org.apache.http.Header;
import org.apache.http.HttpResponse;
import org.apache.http.HttpVersion;
import org.apache.http.NameValuePair;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.utils.URLEncodedUtils;
import org.apache.http.conn.ClientConnectionManager;
import org.apache.http.conn.scheme.PlainSocketFactory;
import org.apache.http.conn.scheme.Scheme;
import org.apache.http.conn.scheme.SchemeRegistry;
import org.apache.http.conn.ssl.SSLSocketFactory;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.impl.conn.tsccm.ThreadSafeClientConnManager;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.params.BasicHttpParams;
import org.apache.http.params.HttpProtocolParams;
import org.apache.http.protocol.HTTP;
import org.apache.http.util.EntityUtils;
import org.json.JSONArray;
import org.json.JSONObject;

import java.net.URLDecoder;
import java.security.KeyStore;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.LinkedList;
import java.util.List;
import java.util.Locale;

import Util.DatabaseHandler;
import Util.MySSLSocketFactory;

import static org.apache.http.params.HttpConnectionParams.setConnectionTimeout;
import static org.apache.http.params.HttpConnectionParams.setSoTimeout;

@SuppressWarnings("ALL")
public class GetMessages extends Service {

    Usuario me;
    DatabaseHandler dbh;

    @Override
    public void onStart(Intent intent, int startId) {
        super.onStart(intent, startId);
    }

    @Override
    public int onStartCommand(final Intent intent, int flags, int startId) {

        dbh = new DatabaseHandler(getApplicationContext());
        me = dbh.getUser();

        final Handler handler = new Handler();
        handler.postDelayed(new Runnable() {
            @Override
            public void run() {

                new FecthMessages().execute();
                handler.postDelayed(this, 1500);

            }
        }, 1500);

        return START_STICKY; //deixa rodando em loop
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
    }

    @Override
    public IBinder onBind(Intent intent) {
        return null;
    }

    private class FecthMessages extends AsyncTask<Void, Void, Void> {

        @Override
        protected Void doInBackground(Void... params) {

            try {

                String ldate = dbh.getLastUpdate(me.getId());

                KeyStore trustStore = KeyStore.getInstance(KeyStore.getDefaultType());
                trustStore.load(null, null);

                MySSLSocketFactory sf = new MySSLSocketFactory(trustStore);
                sf.setHostnameVerifier(SSLSocketFactory.ALLOW_ALL_HOSTNAME_VERIFIER);

                BasicHttpParams httpParams = new BasicHttpParams();
                setConnectionTimeout(httpParams, 3000);
                setSoTimeout(httpParams, 5000);

                HttpProtocolParams.setVersion(httpParams, HttpVersion.HTTP_1_1);
                HttpProtocolParams.setContentCharset(httpParams, HTTP.UTF_8);

                SchemeRegistry registry = new SchemeRegistry();
                registry.register(new Scheme("http", PlainSocketFactory.getSocketFactory(), 80));
                registry.register(new Scheme("https", sf, 443));

                ClientConnectionManager ccm = new ThreadSafeClientConnManager(httpParams, registry);

                HttpClient httpclient = new DefaultHttpClient(ccm, httpParams);
                //HttpClient httpclient = new DefaultHttpClient(httpParams);

                String url = getApplicationContext().getString(R.string.server_address)
                        + "/usuario/" + me.getId() + "/chat";

                if ( !ldate.isEmpty() ){

                    url = url + "?";
                    List<NameValuePair> valuePairs = new LinkedList<>();
                    valuePairs.add(new BasicNameValuePair("ts", ldate));
                    String paramString = URLEncodedUtils.format(valuePairs, HTTP.UTF_8);
                    url += paramString;
                    url = url.replace(" ", "%20");

                }

                HttpGet httpGet = new HttpGet(url);

                String suser = getApplicationContext().getString(R.string.server_user);
                String basicAuth = "Basic " + Base64.encodeToString(suser.getBytes(), Base64.NO_WRAP);
                httpGet.setHeader("Authorization", basicAuth);

                HttpResponse response = httpclient.execute(httpGet);

                if ( response != null && response.getStatusLine().getStatusCode() == 200 ){

                    String ret = URLDecoder.decode(EntityUtils.toString(response.getEntity()), HTTP.UTF_8);
                    JSONArray ja = new JSONArray(ret);

                    Header header = response.getFirstHeader("Date");

                    String sdate = header.getValue();
                    sdate = sdate.substring(0, 25);

                    SimpleDateFormat sdf = new SimpleDateFormat("EEE, dd MMM yyyy HH:mm:ss", Locale.US);

                    Date date = sdf.parse(sdate);
                    sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
                    sdate = sdf.format(date);

                    dbh.setLastUpdate(me.getId(), sdate);

                    if ( ja.length() > 0 ){

                        sdf = new SimpleDateFormat("EEE, dd MMM yyyy HH:mm:ss", Locale.US);

                        for ( int i = 0 ; i < ja.length() ; i++ ){

                            JSONObject jo = ja.getJSONObject(i);

                            Message message = new Message();
                            Usuario u = new Usuario();
                            u.setId(jo.getInt("usuario_id"));
                            message.setChatId(jo.getInt("chat_id"));
                            message.setUsuario(u);
                            message.setMsgId(jo.getInt("m_id"));
                            message.setTexto(new String(jo.getString("texto").getBytes("ISO-8859-1"), HTTP.UTF_8));
                            message.setMsgDate(jo.getString("m_ts").substring(0, 25));

                            if ( u.getId() == me.getId() ){
                                message.setVisto(true);
                            }

                            dbh.addMessage(message);

                        }
                    }

                    //list User/chatID
                    url = getApplicationContext().getString(R.string.server_address)
                            + "/usuario/" + me.getId() + "/chat/listar";

                    httpGet = new HttpGet(url);
                    httpGet.setHeader("Authorization", basicAuth);

                    response = httpclient.execute(httpGet);
                    if ( response != null && response.getStatusLine().getStatusCode() == 200 ){

                        ret = URLDecoder.decode(EntityUtils.toString(response.getEntity()), HTTP.UTF_8);
                        ja = new JSONArray(ret);

                        if ( ja.length() > 0 ){

                            for ( int i = 0 ; i < ja.length() ; i++ ){

                                JSONObject jo = ja.getJSONObject(i);

                                String s = jo.get("id_usuarios").toString().replace("[", "");
                                s = s.replace("]", "");
                                int id = Integer.parseInt(s);

                                int chatId = jo.getInt("chat_id");

                                dbh.setUserChat(chatId, id);
                            }
                        }
                    }

                    int tot = dbh.getCountUnreadMessages();

                    if ( tot == 1 ){

                        NotificationCompat.Builder builder =
                                new NotificationCompat.Builder(getApplicationContext())
                                        .setSmallIcon(R.drawable.message_icon48)
                                        .setContentTitle("Backstage")
                                        .setSound(RingtoneManager.getDefaultUri(RingtoneManager.TYPE_NOTIFICATION))
                                        .setContentText("Você possui uma nova mensagem");

                        int NOTIFICATION_ID = 123454321;

                        NotificationManager nManager = (NotificationManager) getSystemService(NOTIFICATION_SERVICE);
                        nManager.notify(NOTIFICATION_ID, builder.build());

                    }
                    else if ( tot == 1 ){

                        NotificationCompat.Builder builder =
                                new NotificationCompat.Builder(getApplicationContext())
                                        .setSmallIcon(R.drawable.message_icon48)
                                        .setContentTitle("Backstage")
                                        .setSound(RingtoneManager.getDefaultUri(RingtoneManager.TYPE_NOTIFICATION))
                                        .setContentText("Você possui " + tot + " novas mensagens" );

                        int NOTIFICATION_ID = 123454321;

                        NotificationManager nManager = (NotificationManager) getSystemService(NOTIFICATION_SERVICE);
                        nManager.notify(NOTIFICATION_ID, builder.build());

                    }

                    response.getEntity().consumeContent();
                    httpGet.abort();
                    httpclient.getConnectionManager().closeExpiredConnections();
                    httpclient.getConnectionManager().shutdown();

                }
            }
            catch (Exception e) { e.printStackTrace(); }

            return null;
        }
    }
}
