package tads.ufpr.pr.br.backstage;

import android.os.Parcel;
import android.os.Parcelable;

import java.io.Serializable;
import java.util.List;

public class InstType implements Parcelable {

    private static final long serialVersionUID = 1L;

    private int typeId;
    private int typeLogo;
    private String typeName;
    private List<Instrumento> instrumentos;

    public InstType(){
        super();
    }

    public InstType(int typeId, int typeLogo, String typeName) {
        this.typeId = typeId;
        this.typeLogo = typeLogo;
        this.typeName = typeName;
    }

    protected InstType(Parcel in) {
        typeId = in.readInt();
        typeLogo = in.readInt();
        typeName = in.readString();
    }

    public static final Creator<InstType> CREATOR = new Creator<InstType>() {
        @Override
        public InstType createFromParcel(Parcel in) {
            return new InstType(in);
        }

        @Override
        public InstType[] newArray(int size) {
            return new InstType[size];
        }
    };

    public int getTypeId() {
        return typeId;
    }

    public void setTypeId(int typeId) {
        this.typeId = typeId;
    }

    public int getTypeLogo() {
        return typeLogo;
    }

    public void setTypeLogo(int typeLogo) { this.typeLogo = typeLogo; }

    public String getTypeName() {
        return typeName;
    }

    public void setTypeName(String typeName) {
        this.typeName = typeName;
    }

    public List<Instrumento> getInstrumentos() {
        return instrumentos;
    }

    public void setInstrumentos(List<Instrumento> instrumentos) {
        this.instrumentos = instrumentos;
    }

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeInt(typeId);
        dest.writeInt(typeLogo);
        dest.writeString(typeName);
    }
}
