package tads.ufpr.pr.br.backstage;

import android.app.Activity;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import java.util.List;

public class InstTypeSpinnerAdapter extends ArrayAdapter<InstType> {

    int groupid;
    Activity context;
    List<InstType> linstType;
    LayoutInflater inflater;

    public InstTypeSpinnerAdapter(Activity context, int groupid, int id, List<InstType> linstType){
        super(context,id, linstType);

        this.linstType = linstType;
        this.inflater  = (LayoutInflater)context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        this.groupid   = groupid;
    }

    public View getView(int position, View convertView, ViewGroup parent ){

        View itemView = inflater.inflate( R.layout.insttype_item , parent,false);

        ImageView imageView = (ImageView)itemView.findViewById(R.id.iv_insttype_logo);
        imageView.setImageResource(linstType.get(position).getTypeLogo());

        TextView textView = (TextView)itemView.findViewById(R.id.tv_instTypeName);
        textView.setText(linstType.get(position).getTypeName());

        return itemView;
    }

    public View getDropDownView(int position, View convertView, ViewGroup parent){
        return getView(position,convertView,parent);
    }
}
