package tads.ufpr.pr.br.backstage;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Bitmap;
import android.os.AsyncTask;
import android.os.Environment;
import android.support.v7.widget.RecyclerView;
import android.text.format.DateUtils;
import android.util.Base64;
import android.view.View;
import android.widget.ImageView;
import android.widget.TextView;

import com.android.volley.VolleyError;
import com.android.volley.toolbox.ImageLoader;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.HttpVersion;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpDelete;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.params.BasicHttpParams;
import org.apache.http.params.HttpProtocolParams;
import org.apache.http.protocol.HTTP;
import org.apache.http.util.ByteArrayBuffer;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.UnsupportedEncodingException;
import java.net.MalformedURLException;
import java.util.Calendar;
import java.util.Date;

import Util.PlayDialog;
import Util.RoundImage;
import Util.Utils;

import static org.apache.http.params.HttpConnectionParams.setConnectionTimeout;
import static org.apache.http.params.HttpConnectionParams.setSoTimeout;

@SuppressWarnings("All")
public class ItemViewHolder extends RecyclerView.ViewHolder {

    private ImageView       _ivUserImage;
    private TextView        _tvUserName;
    private TextView        _tvTime;
    private TextView        _tvText;
    private FeedImageView   _ivImage;

    private Usuario me;
    private Activity activity;

    public ItemViewHolder(View itemView, Activity activity) {
        super(itemView);

        this.activity = activity;
        this.me = ((AppController)activity.getApplication()).getUsuario();

        _ivUserImage = (ImageView)itemView.findViewById(R.id.iv_user_image);
        _tvUserName  = (TextView)itemView.findViewById(R.id.tv_userName);
        _tvTime      = (TextView)itemView.findViewById(R.id.tv_time);
        _tvText      = (TextView)itemView.findViewById(R.id.tv_text);
        _ivImage     = (FeedImageView)itemView.findViewById(R.id.iv_image);

    }

    public static void bindHolder1(final ItemViewHolder holder, final Post post){

        ImageLoader imageLoader = AppController.getInstance().getImageLoader();

        holder.bindSame(holder, post);

        if ( post.getPostType() == 2 || post.getPostType() == 3 ){

            String url = "";

            if ( post.getPostType() == 2  ){

                url = post.getAnexo();

            }
            else {

                url = holder.activity.getString(R.string.server_address)
                        + "/postagem/anexo/" + post.getAnexo();

                holder._ivImage.setResponseObserver(new FeedImageView.ResponseObserver() {

                    @Override
                    public void onError(VolleyError error) {
                        //Toast.makeText(holder.activity, "Erro ao carregar imagem", Toast.LENGTH_LONG).show();
                        error.printStackTrace();
                    }

                    @Override
                    public void onSuccess() {
                        //Toast.makeText(holder.activity, "Anexo", Toast.LENGTH_LONG).show();
                    }
                });


            }

            holder._ivImage.setImageUrl(url, imageLoader, holder.activity);

        }
        else
            holder._ivImage.setVisibility(View.GONE);

    }

    public static void bindHolder2(final ItemViewHolder holder, final Post post){

        holder.bindSame(holder, post);

        if ( post.getAnexo() != null ){

            final File path = new File( Environment.getExternalStorageDirectory().getAbsolutePath()
                    + holder.activity.getString(R.string.filepath) + "/downloads/" + post.getAnexo());

            holder.itemView.setOnClickListener(new View.OnClickListener() {

                @Override
                public void onClick(View v) {

                    if ( post.getPostType() == 4 ){

                        if ( path.exists() ) {

                            android.app.FragmentManager fm = holder.activity.getFragmentManager();
                            PlayDialog playDialog = new PlayDialog();
                            playDialog.setFileName("/downloads/" + post.getAnexo(), 0);
                            playDialog.show(fm, "Play Dialog");

                        }
                        else {

                            new DownloadFile(post.getAnexo(), holder.activity).execute();

                        }
                    }
                }
            });

        }
    }

    public void bindSame(final ItemViewHolder holder, final Post post){

        if ( post.getUsuario().getImagem() != null && !post.getUsuario().getImagem().isEmpty()
                && !post.getUsuario().getImagem().equals("null") ){

            Bitmap bm = Utils.string2Bitmap(post.getUsuario().getImagem());
            RoundImage rm = new RoundImage(bm);
            holder._ivUserImage.setImageDrawable(rm);

        }
        else
            holder._ivUserImage.setImageResource(R.drawable.aboutme);


        if ( post.getUsuario().getId() == holder.me.getId() )
            holder._tvUserName.setText("Eu");
        else
            holder._tvUserName.setText(post.getUsuario().getNome());

        Calendar cal = Calendar.getInstance();
        cal.setTime(new Date());
        /*
        cal.add(Calendar.HOUR_OF_DAY, 1);
        cal.add(Calendar.MINUTE, 59);
        cal.add(Calendar.SECOND, 14);
        */

        cal.add(Calendar.SECOND, -5);

        Date date = cal.getTime();

        CharSequence timeAgo = DateUtils.getRelativeTimeSpanString(Long.parseLong(
                post.getTimeStamp()), date.getTime(), DateUtils.SECOND_IN_MILLIS);

        holder._tvTime.setText(timeAgo);

        if ( !post.getText().equals("null") )
            holder._tvText.setText(post.getText());

        holder.itemView.setOnLongClickListener(new View.OnLongClickListener() {

            @Override
            public boolean onLongClick(View v) {

                if (post.getUsuario().getId() == holder.me.getId()) {

                    AlertDialog.Builder adbuilder = new AlertDialog.Builder(holder.activity);
                    adbuilder.setItems(R.array.remove_array, new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialog, int which) {

                            if (which == 1) {

                                Intent i = new Intent(holder.activity, PostActivity.class);
                                i.putExtra("post", post);
                                holder.activity.startActivity(i);

                            } else {

                                AlertDialog.Builder adb = new AlertDialog.Builder(holder.activity);
                                adb.setTitle("Remover publicação");
                                adb.setMessage("Deseja remover sua publicação? A ação não poderá ser desfeita");
                                adb.setNegativeButton("Cancelar", new DialogInterface.OnClickListener() {
                                    @Override
                                    public void onClick(DialogInterface dialog, int which) {
                                        dialog.cancel();
                                        dialog.dismiss();
                                    }
                                });

                                adb.setPositiveButton("Remover", new DialogInterface.OnClickListener() {
                                    @Override
                                    public void onClick(DialogInterface dialog, int which) {
                                        new DeletePost(holder.activity, post).execute();
                                        dialog.cancel();
                                        dialog.dismiss();
                                    }
                                });

                                adb.show();
                            }
                        }
                    });

                    adbuilder.show();
                }

                return true;
            }
        });

    }

    public static class DownloadFile extends AsyncTask<Void, Void, Void> {

        String file;
        boolean donloaded;
        Activity activity;
        HttpResponse response;
        ProgressDialog progressDialog;

        public DownloadFile(String file, Activity activity){
            this.file = file;
            this.activity = activity;
        }

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

            progressDialog = new ProgressDialog(activity, R.style.AppTheme_Dark_Dialog);
            progressDialog.setIndeterminate(true);
            progressDialog.setCancelable(false);
            progressDialog.setMessage("Carregando...");
            progressDialog.show();

        }

        @Override
        protected void onPostExecute(Void aVoid) {
            super.onPostExecute(aVoid);

            progressDialog.cancel();
            progressDialog.dismiss();

            if ( donloaded ){

                android.app.FragmentManager fm = activity.getFragmentManager();
                PlayDialog playDialog = new PlayDialog();
                playDialog.setFileName("/downloads/" + file , 0);
                playDialog.show(fm, "Play Dialog");

            }
        }

        @Override
        protected Void doInBackground(Void... params) {

            try {

                BasicHttpParams httpParams = new BasicHttpParams();
                setConnectionTimeout(httpParams, 3000);
                setSoTimeout(httpParams, 5000);
                HttpClient httpclient = new DefaultHttpClient(httpParams);

                String surl = activity.getString(R.string.server_address) +
                        "/postagem/download/" + file;

                String user = activity.getResources().getString(R.string.server_user);
                String basicAuth = "Basic " + Base64.encodeToString(user.getBytes(), Base64.NO_WRAP);

                HttpGet httpGet = new HttpGet(surl);
                httpGet.setHeader("Authorization", basicAuth);

                response = httpclient.execute(httpGet);
                HttpEntity entity = response.getEntity();
                if (entity != null) {

                    File path = new File( Environment.getExternalStorageDirectory().getAbsolutePath()
                            + activity.getString(R.string.filepath) + "/downloads/");

                    path.mkdir();

                    path = new File( Environment.getExternalStorageDirectory().getAbsolutePath()
                            + activity.getString(R.string.filepath) + "/downloads/" + file);

                    if (path.exists()) {
                        path.delete();
                    }

                    long len = entity.getContentLength();
                    InputStream inputStream = entity.getContent();
                    BufferedInputStream bis = new BufferedInputStream(inputStream);

                    ByteArrayBuffer baf = new ByteArrayBuffer(50);
                    int current = 0;
                    while ((current = bis.read()) != -1) {
                        baf.append((byte) current);
                    }

                    FileOutputStream fos = new FileOutputStream(path);
                    fos.write(baf.toByteArray());
                    fos.close();

                    donloaded = true;

                }

            } catch (MalformedURLException e) {
                e.printStackTrace();
            } catch (UnsupportedEncodingException e) {
                e.printStackTrace();
            } catch (IOException e) {
                e.printStackTrace();
            }
            return null;
        }
    }

    public static class DeletePost extends AsyncTask<Void, Void, Void> {

        Post post;
        Activity activity;
        ProgressDialog progressDialog;
        HttpResponse response;

        public DeletePost(Activity activity, Post post) {
            this.post = post;
            this.activity = activity;
        }

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

            progressDialog = new ProgressDialog(activity, R.style.AppTheme_Dark_Dialog);
            progressDialog.setIndeterminate(true);
            progressDialog.setCancelable(false);
            progressDialog.setMessage("Deletando postagem...");
            progressDialog.show();

        }

        @Override
        protected void onPostExecute(Void aVoid) {
            super.onPostExecute(aVoid);

            progressDialog.cancel();
            progressDialog.dismiss();

            if ( response != null && response.getStatusLine().getStatusCode() == 204 ){

                Intent i = new Intent(activity, MainActivity.class);
                activity.startActivity(i);
                activity.finish();

            }
        }

        @Override
        protected Void doInBackground(Void... params) {

            HttpClient httpclient;

            try {

                /*
                KeyStore trustStore = KeyStore.getInstance(KeyStore.getDefaultType());
                trustStore.load(null, null);

                MySSLSocketFactory sf = new MySSLSocketFactory(trustStore);
                sf.setHostnameVerifier(SSLSocketFactory.ALLOW_ALL_HOSTNAME_VERIFIER);
                */

                BasicHttpParams httpParams = new BasicHttpParams();
                setConnectionTimeout(httpParams, 3000);
                setSoTimeout(httpParams, 5000);

                HttpProtocolParams.setVersion(httpParams, HttpVersion.HTTP_1_1);
                HttpProtocolParams.setContentCharset(httpParams, HTTP.UTF_8);

                /*
                SchemeRegistry registry = new SchemeRegistry();
                registry.register(new Scheme("http", PlainSocketFactory.getSocketFactory(), 80));
                registry.register(new Scheme("https", sf, 443));

                ClientConnectionManager ccm = new ThreadSafeClientConnManager(httpParams, registry);

                HttpClient httpclient = new DefaultHttpClient(ccm, httpParams);
                */

                httpclient = new DefaultHttpClient(httpParams);

                HttpDelete httpDelete = new HttpDelete(activity.getResources().getString(
                        R.string.server_address) + "/usuario/" + post.getUsuario().getId() +
                        "/postagem/" + post.getPostId() );

                String user = activity.getResources().getString(R.string.server_user);
                String basicAuth = "Basic " + Base64.encodeToString(user.getBytes(), Base64.NO_WRAP);
                httpDelete.setHeader("Authorization", basicAuth);

                response = httpclient.execute(httpDelete);

                httpDelete.abort();
                httpclient.getConnectionManager().closeExpiredConnections();
                httpclient.getConnectionManager().shutdown();

            } catch (IOException e) {
                e.printStackTrace();
            }

            return null;
        }
    }
}
