package tads.ufpr.pr.br.backstage;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.support.design.widget.CoordinatorLayout;
import android.support.design.widget.Snackbar;
import android.support.v4.app.Fragment;
import android.os.Bundle;
import android.os.Environment;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.text.InputType;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.EditText;
import android.widget.TextView;
import java.io.File;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import Util.PlayDialog;

public class LocalAudioFilesFragment extends Fragment {

    View v;
    Usuario u;
    RecyclerView recyclerView;
    FileRecyclerAdapter recyclerAdapter;
    CoordinatorLayout coordinatorLayout;
    List<String> filesNames = new ArrayList<>();

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {

        View v = inflater.inflate(R.layout.generic_recycler_view_frag, container, false);

        u = ((AppController)getActivity().getApplication()).getUsuario();

        recyclerView = (RecyclerView)v.findViewById(R.id.recyclerView);
        coordinatorLayout = (CoordinatorLayout)getActivity().findViewById(R.id
                .coordinatorLayout);
        setupRecyclerView(recyclerView);

        return v;
    }

    private void setupRecyclerView(final RecyclerView recyclerView) {

        recyclerView.setLayoutManager(new LinearLayoutManager(getActivity()));
        recyclerAdapter = new FileRecyclerAdapter(createItemList());
        recyclerView.setAdapter(recyclerAdapter);

        recyclerView.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {

                recyclerAdapter = new FileRecyclerAdapter(createItemList());
                recyclerView.setAdapter(recyclerAdapter);
            }
        });
    }

    private List<String> createItemList() {

        File path = new File( Environment.getExternalStorageDirectory().getAbsolutePath()
                + getString(R.string.filepath) + "/" + u.getId() + "/" );

        File[] f = path.listFiles();

        filesNames.clear();

        if ( f != null )
            for (int i=0; i < f.length; i++)
                filesNames.add(f[i].getName());

        Collections.sort(filesNames);

        return filesNames;
    }

    public class FileRecyclerAdapter extends RecyclerView.Adapter<RecyclerView.ViewHolder> {

        private List<String> mItemList;

        public FileRecyclerAdapter(List<String> itemList) {
            mItemList = itemList;
        }

        public List<String> getItems(){
            return mItemList;
        }

        @Override
        public RecyclerView.ViewHolder onCreateViewHolder(final ViewGroup parent, int viewType) {
            View view = LayoutInflater.from(parent.getContext()).inflate(R.layout.recycler_item, parent, false);

            view.setOnClickListener(new View.OnClickListener() {

                @Override
                public void onClick(final View v) {

                    final String filename = ((TextView) v.findViewById(R.id.itemTextView)).getText().toString();

                    AlertDialog.Builder adbuilder = new AlertDialog.Builder(getActivity());
                    adbuilder.setTitle("Opções de arquivo:")
                            .setItems(R.array.record_options_array, new DialogInterface.OnClickListener() {
                                public void onClick(DialogInterface dialog, int which) {

                                    if (which == 0) { // Ouvir

                                        android.app.FragmentManager fm = getActivity().getFragmentManager();
                                        PlayDialog playDialog = new PlayDialog();
                                        playDialog.setFileName(((TextView)v.findViewById(
                                                R.id.itemTextView)).getText().toString(), u.getId());

                                        playDialog.show(fm, "Play Dialog");

                                    } else if (which == 1) { // Renomear

                                        AlertDialog.Builder builder = new AlertDialog.Builder(getActivity());
                                        builder.setTitle("Renomear o arquivo:");
                                        final EditText input = new EditText(getActivity());
                                        input.setInputType(InputType.TYPE_CLASS_TEXT);
                                        input.setText(filename);
                                        builder.setView(input);

                                        builder.setPositiveButton("Salvar", new DialogInterface.OnClickListener() {
                                            @Override
                                            public void onClick(DialogInterface dialog, int which) {

                                                dialog.cancel();
                                                String new_name = input.getText().toString();
                                                if ( new_name.isEmpty() ){

                                                    Snackbar.make(coordinatorLayout, "Ops! Acidentalmente você tentou renomear o " +
                                                                    "arquivo sem inserir um novo nome", Snackbar.LENGTH_LONG).show();

                                                }
                                                else{

                                                    File path = new File( Environment.getExternalStorageDirectory().getAbsolutePath()
                                                            + getString(R.string.filepath) + u.getId() + "/" + new_name );

                                                    if ( !path.exists() ){

                                                        if ( !new_name.endsWith(".mp3") )
                                                            new_name = new_name + ".mp3";

                                                        File oldPath = new File( Environment.getExternalStorageDirectory().getAbsolutePath()
                                                                + getString(R.string.filepath) + u.getId() + "/" + filename );

                                                        if (oldPath.renameTo(path)){

                                                            Snackbar.make(coordinatorLayout, "Arquivo renomeado!", Snackbar.LENGTH_LONG).show();

                                                            int i = 0;
                                                            for (String s : recyclerAdapter.getItems()) {

                                                                if ( s.equals(filename)) {
                                                                    recyclerAdapter.getItems().remove(i);
                                                                    recyclerAdapter.getItems().add(i, new_name);
                                                                    Collections.sort(recyclerAdapter.getItems());
                                                                    recyclerAdapter.notifyDataSetChanged();
                                                                    break;
                                                                }
                                                                i++;
                                                            }

                                                        }
                                                    }
                                                    else
                                                        Snackbar.make(coordinatorLayout, "Ops! Já existe um arquivo com "
                                                                + "mesmo nome", Snackbar.LENGTH_LONG).show();

                                                }
                                            }
                                        });
                                        builder.setNegativeButton("Cancelar", new DialogInterface.OnClickListener() {
                                            @Override
                                            public void onClick(DialogInterface dialog, int which) {
                                                dialog.cancel();
                                            }
                                        });

                                        builder.show();

                                    } else { // Excluir

                                        final File file = new File(Environment.getExternalStorageDirectory().getAbsolutePath()
                                                + getString(R.string.filepath) + u.getId() + "/" + filename);

                                        if (file.exists()) {

                                            AlertDialog.Builder builder = new AlertDialog.Builder(getActivity());
                                            builder.setTitle("Excluir arquivo");
                                            builder.setMessage("Deseja remover o arquivo " + filename + "?" );

                                            builder.setPositiveButton("Excluir", new DialogInterface.OnClickListener() {
                                                @Override
                                                public void onClick(DialogInterface dialog, int which) {

                                                    dialog.cancel();

                                                    if ( file.delete()) {

                                                        int i = 0;
                                                        for (String s : recyclerAdapter.getItems()) {

                                                            if (s.equals(filename)) {
                                                                recyclerAdapter.getItems().remove(i);
                                                                recyclerAdapter.notifyDataSetChanged();
                                                                break;
                                                            }
                                                            i++;
                                                        }

                                                        Snackbar.make(coordinatorLayout, "Arquivo " + filename
                                                                + " removido!", Snackbar.LENGTH_LONG).show();

                                                    } else
                                                        Snackbar.make(coordinatorLayout,
                                                                "Erro ao remover rquivo " + filename, Snackbar.LENGTH_LONG).show();

                                                }
                                            });

                                            builder.setNegativeButton("Cancelar", new DialogInterface.OnClickListener() {
                                                @Override
                                                public void onClick(DialogInterface dialog, int which) {
                                                    dialog.cancel();
                                                }
                                            });

                                            builder.show();

                                        }
                                    }
                                }
                            });

                    adbuilder.show();

                }
            });

            return RecyclerItemViewHolder.newInstance(view);
        }

        @Override
        public void onBindViewHolder(RecyclerView.ViewHolder viewHolder, int position) {
            RecyclerItemViewHolder holder = (RecyclerItemViewHolder) viewHolder;
            String itemText = mItemList.get(position);
            holder.setItemText(itemText);
        }

        @Override
        public int getItemCount() {
            return mItemList == null ? 0 : mItemList.size();
        }

    }
}
