package tads.ufpr.pr.br.backstage;

import android.os.AsyncTask;
import android.os.Bundle;
import android.support.annotation.Nullable;
import android.support.design.widget.Snackbar;
import android.support.v4.app.Fragment;
import android.support.v4.widget.SwipeRefreshLayout;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.util.Base64;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import org.apache.http.HttpResponse;
import org.apache.http.HttpVersion;
import org.apache.http.NameValuePair;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.utils.URLEncodedUtils;
import org.apache.http.conn.ClientConnectionManager;
import org.apache.http.conn.scheme.PlainSocketFactory;
import org.apache.http.conn.scheme.Scheme;
import org.apache.http.conn.scheme.SchemeRegistry;
import org.apache.http.conn.ssl.SSLSocketFactory;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.impl.conn.tsccm.ThreadSafeClientConnManager;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.params.BasicHttpParams;
import org.apache.http.params.HttpProtocolParams;
import org.apache.http.protocol.HTTP;
import org.apache.http.util.EntityUtils;
import org.json.JSONArray;
import org.json.JSONObject;

import java.net.URLDecoder;
import java.security.KeyStore;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.LinkedList;
import java.util.List;

import Util.DatabaseHandler;
import Util.MySSLSocketFactory;
import Util.Utils;

import static org.apache.http.params.HttpConnectionParams.setConnectionTimeout;
import static org.apache.http.params.HttpConnectionParams.setSoTimeout;

@SuppressWarnings("All")
public class NewsFeed extends Fragment {

    int see;
    Usuario me;
    int offset;
    Bundle extras;
    List<Post> lPost;
    boolean refreshing;
    RecyclerView _recView;
    RecyclerAdapter recyclerAdapter;
    EndlessRecyclerOnScrollListener scrollListener;
    SwipeRefreshLayout mSwipeRefreshLayout;

    @Override
    public View onCreateView(LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {

        View v = inflater.inflate(R.layout.timeline_layout, container, false);

        mSwipeRefreshLayout = (SwipeRefreshLayout)v.findViewById(R.id.swipeRefreshLayout);
        mSwipeRefreshLayout.setColorSchemeResources(R.color.color_primary_dark);

        me = ((AppController)getActivity().getApplication()).getUsuario();
        lPost = new ArrayList<>();

        extras = getActivity().getIntent().getExtras();
        if ( extras != null ){

            Usuario u = (Usuario)extras.getSerializable("user");
            see = u.getId();

        }

        _recView = (RecyclerView)v.findViewById(R.id.recyclerView);

        recyclerAdapter = new RecyclerAdapter(getActivity(), lPost);
        _recView.setAdapter(recyclerAdapter);

        final LinearLayoutManager llm = new LinearLayoutManager(getActivity());
        _recView.setLayoutManager(llm);
        _recView.setHasFixedSize(true);

        scrollListener = new EndlessRecyclerOnScrollListener(llm) {

            @Override
            public void onLoadMore(int offset) {
                offset = lPost.size();
                if (Utils.isNetworkOnline(getActivity()))
                    new FetchPostData().execute();
                else
                    Snackbar.make(mSwipeRefreshLayout, getResources().getString(R.string.no_network_text),
                            Snackbar.LENGTH_LONG).show();
            }
        };

        mSwipeRefreshLayout.setOnRefreshListener(new SwipeRefreshLayout.OnRefreshListener() {
            @Override
            public void onRefresh() {

                if (Utils.isNetworkOnline(getActivity())) {
                    offset = 0;
                    lPost.clear();
                    refreshing = true;
                    new FetchPostData().execute();
                }
                else {

                    refreshing = false;
                    mSwipeRefreshLayout.setRefreshing(false);
                    Snackbar.make(mSwipeRefreshLayout, getResources().getString(R.string.no_network_text),
                            Snackbar.LENGTH_LONG).show();
                }
            }
        });

        if (Utils.isNetworkOnline(getActivity()))
            new FetchPostData().execute();

        return v;
    }

    private class FetchPostData extends AsyncTask<Void, Void, Void>{

        String url;
        HttpGet httpGet;
        HttpResponse response;
        private Exception exceptionToBeThrown;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

            if ( see != 0 )
                url = getString( R.string.server_address ) + "/usuario/" + see
                        + "/postagem?";

            else if ( see == 0 && getActivity().getClass() == ProfileActivity.class )
                url = getString( R.string.server_address ) + "/usuario/" + me.getId()
                        + "/postagem?";

            else
                url = getString( R.string.server_address ) + "/usuario/" + me.getId()
                        + "/timeline?";

            List<NameValuePair> params = new LinkedList<>();
            params.add(new BasicNameValuePair("offset", String.valueOf(offset)));
            String paramString = URLEncodedUtils.format(params, HTTP.UTF_8);
            url += paramString;

            url = url.replace(" ", "%20");

            httpGet = new HttpGet(url);
        }

        @Override
        protected void onPostExecute(Void aVoid) {
            super.onPostExecute(aVoid);

            if ( refreshing ){

                mSwipeRefreshLayout.setRefreshing(false);

            }

            recyclerAdapter.notifyDataSetChanged();

        }

        @Override
        protected Void doInBackground(Void... params) {

            try {

                KeyStore trustStore = KeyStore.getInstance(KeyStore.getDefaultType());
                trustStore.load(null, null);

                MySSLSocketFactory sf = new MySSLSocketFactory(trustStore);
                sf.setHostnameVerifier(SSLSocketFactory.ALLOW_ALL_HOSTNAME_VERIFIER);

                BasicHttpParams httpParams = new BasicHttpParams();
                setConnectionTimeout(httpParams, 3000);
                setSoTimeout(httpParams, 5000);

                HttpProtocolParams.setVersion(httpParams, HttpVersion.HTTP_1_1);
                HttpProtocolParams.setContentCharset(httpParams, HTTP.UTF_8);

                SchemeRegistry registry = new SchemeRegistry();
                registry.register(new Scheme("http", PlainSocketFactory.getSocketFactory(), 80));
                registry.register(new Scheme("https", sf, 443));

                ClientConnectionManager ccm = new ThreadSafeClientConnManager(httpParams, registry);

                HttpClient httpclient = new DefaultHttpClient(ccm, httpParams);

                httpclient = new DefaultHttpClient(httpParams);

                String user = getResources().getString(R.string.server_user);
                String basicAuth = "Basic " + Base64.encodeToString(user.getBytes(), Base64.NO_WRAP);
                httpGet.setHeader("Authorization", basicAuth);

                response = httpclient.execute(httpGet);

                String ret = URLDecoder.decode(EntityUtils.toString(response.getEntity()), HTTP.UTF_8);

                if ( response != null && response.getStatusLine().getStatusCode() == 200 ) {

                    JSONArray ja = new JSONArray(ret);

                    if ( ja != null ){

                        int size = ja.length();
                        for ( int i = 0; i < size ; i++ ){

                            JSONObject jo = ja.getJSONObject(i);
                            Post post = new Post();

                            post.setPostId(Integer.parseInt(jo.getString("id")));
                            post.setPostType(Integer.parseInt(jo.getString("tipo_postagem_id")));
                            post.setText(new String(jo.getString("texto").getBytes("ISO-8859-1"), HTTP.UTF_8));
                            post.setTimeStamp(new String(jo.getString("insert_ts").getBytes("ISO-8859-1"), HTTP.UTF_8));

                            post.setTimeStamp(post.getTimeStamp().substring(0, 23));

                            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss.SSSSSS");
                            Date date = sdf.parse(post.getTimeStamp());

                            post.setTimeStamp(String.valueOf(date.getTime()));

                            if ( post.getPostType() == 2 ){

                                String s = new String(jo.getString("link").getBytes("ISO-8859-1"), HTTP.UTF_8);
                                post.setAnexo(s);

                            }
                            else if ( post.getPostType() == 3 ){

                                String s = new String(jo.getString("anexo").getBytes("ISO-8859-1"), HTTP.UTF_8);
                                post.setAnexo(s);

                            }
                            else if ( post.getPostType() == 4 ){

                                String s = new String(jo.getString("anexo").getBytes("ISO-8859-1"), HTTP.UTF_8);
                                //post.setAnexo( downloadFile(s, post.getPostId(), basicAuth ) );
                                post.setAnexo(s);

                            }

                            if ( see == 0 ){

                                if ( Integer.parseInt(jo.getString("usuario_id")) == me.getId() )
                                    post.setUsuario(me);
                                else {

                                    DatabaseHandler dbh = new DatabaseHandler(getActivity());
                                    post.setUsuario(dbh.getFriend(Integer.parseInt(jo.getString("usuario_id"))));

                                }

                            }
                            else {

                                Usuario u = (Usuario)extras.getSerializable("user");
                                post.setUsuario(u);

                            }
                            lPost.add(post);
                        }
                    }
                }

                httpGet.abort();
                httpclient.getConnectionManager().closeExpiredConnections();
                httpclient.getConnectionManager().shutdown();

            }
            catch (Exception e) {
                e.printStackTrace();
                exceptionToBeThrown = e;
            }
            return null;
        }

    }
}
