package tads.ufpr.pr.br.backstage;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.ActivityNotFoundException;
import android.content.DialogInterface;
import android.content.Intent;
import android.database.Cursor;
import android.graphics.BitmapFactory;
import android.media.MediaPlayer;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Environment;
import android.os.SystemClock;
import android.provider.MediaStore;
import android.support.design.widget.FloatingActionButton;
import android.support.design.widget.Snackbar;
import android.support.v4.content.ContextCompat;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.text.Editable;
import android.text.TextWatcher;
import android.util.DisplayMetrics;
import android.util.Patterns;
import android.view.Display;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Chronometer;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ProgressBar;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;

import com.android.volley.toolbox.ImageLoader;

import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import Util.UploadFile;
import butterknife.ButterKnife;
import butterknife.InjectView;

public class PostActivity extends AppCompatActivity {

    //Link Attachment
    @InjectView(R.id.et_text)       EditText        _postText;
    @InjectView(R.id.iv_link)       FeedImageView   _postLinkImg;
    @InjectView(R.id.tv_headerTxt)  TextView        _imgHeader;
    @InjectView(R.id.linkBg)        LinearLayout    _linkBg;

    //Image Attachment
    @InjectView(R.id.imageBg)        LinearLayout    _imageBg;
    @InjectView(R.id.iv_Image)       ImageView       _postImage;

    //Áudio Attachment
    @InjectView(R.id.songBg)         RelativeLayout  _songBg;
    @InjectView(R.id.btnPlay)        ImageButton     _btnPlay;
    @InjectView(R.id.fileName)       TextView        _fileName;
    @InjectView(R.id.pgMusic)        ProgressBar     _pgMusic;
    @InjectView(R.id.countPg)        Chronometer     _pgCount;
    @InjectView(R.id.totPg)          TextView        _pgTot;

    @InjectView(R.id.bgAttach)      RelativeLayout  _attachBg;
    @InjectView(R.id.close)         ImageButton     _close;
    @InjectView(R.id.fabButton)     FloatingActionButton _btnPost;

    Usuario u;
    Uri picUri;
    String src;
    int count = 0;
    String fileName;
    boolean isPlaying;
    MediaPlayer mPlayer;
    AlertDialog.Builder adbuilder;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_post);

        ButterKnife.inject(this);
        u = ((AppController)this.getApplication()).getUsuario();

        initToolBar();

        _postText.requestFocus();
        _postText.addTextChangedListener(new TextWatcher() {

            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {
            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {
            }

            @Override
            public void afterTextChanged(Editable s) {

                if (_imageBg.getVisibility() != View.VISIBLE && _songBg.getVisibility() != View.VISIBLE
                        && _linkBg.getVisibility() != View.VISIBLE) {

                    if (_postText.getText().toString().length() > 0) {

                        char c = _postText.getText().toString().charAt(_postText.getText().toString().length() - 1);

                        if (c == ' ' || c == '\n') {
                            String words[] = _postText.getText().toString().split(String.valueOf(c));
                            for (String word : words) {
                                if (Patterns.WEB_URL.matcher(word).matches() && _postLinkImg.getDrawable() == null) {
                                    new FindAndAttachLink().execute(word);
                                }
                            }
                        }
                    }

                }
            }
        });

        _close.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                adbuilder = new AlertDialog.Builder(PostActivity.this);
                adbuilder.setTitle(R.string.remove_attach);
                adbuilder.setMessage(R.string.remove_attach_text);

                adbuilder.setNegativeButton(R.string.cancel, new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        dialog.cancel();
                        dialog.dismiss();
                    }
                });

                adbuilder.setPositiveButton(R.string.yes, new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        cleanAttachment();
                    }
                });

                adbuilder.show();
            }
        });

        _btnPost.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                if (_imageBg.getVisibility() == View.VISIBLE) {

                    new UploadFile(PostActivity.this, u, picUri, _postText.getText().toString()).execute();

                } else if (_songBg.getVisibility() == View.VISIBLE) {

                    new UploadFile(PostActivity.this, u, fileName, _postText.getText().toString()).execute();

                } else if (_linkBg.getVisibility() == View.VISIBLE) {

                    new UploadFile(PostActivity.this, u, null, src, _postText.getText().toString()).execute();

                } else if (!_postText.getText().toString().isEmpty()) {

                    new UploadFile(PostActivity.this, u, _postText.getText().toString()).execute();

                }
            }
        });

        _btnPlay.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                if (isPlaying) {

                    _pgCount.stop();
                    _pgCount.setBase(SystemClock.elapsedRealtime());

                    isPlaying = false;

                    _btnPlay.setBackground(ContextCompat.getDrawable(
                            PostActivity.this, R.drawable.play));

                    mPlayer.stop();
                    mPlayer.reset();
                    mPlayer.release();

                    try {

                        mPlayer = new MediaPlayer();

                        File path = new File(Environment.getExternalStorageDirectory().getAbsolutePath()
                                + getString(R.string.filepath) + "/" + u.getId() + "/" + fileName);

                        mPlayer.setDataSource(path.getPath());
                        mPlayer.prepare();

                    } catch (IOException e) {
                        Snackbar.make(findViewById(R.id.coordinatorLayout),
                                "Erro ao abrir o arquivo " + fileName,
                                Snackbar.LENGTH_LONG).show();
                    }

                    _pgMusic.setProgress(0);
                    _pgMusic.setProgress(0);
                    _pgMusic.setProgress(0);


                } else {

                    count = 0;
                    isPlaying = true;

                    _btnPlay.setBackground(ContextCompat.getDrawable(
                            PostActivity.this, R.drawable.stop));

                    _pgCount.setOnChronometerTickListener(new Chronometer.OnChronometerTickListener() {
                        @Override
                        public void onChronometerTick(Chronometer chronometer) {

                            count++;

                            if (count >= 3)
                                _pgMusic.setProgress(_pgMusic.getProgress() + 1);

                        }
                    });

                    _pgCount.setBase(SystemClock.elapsedRealtime());
                    _pgCount.start();

                    mPlayer.start();

                    mPlayer.setOnCompletionListener(new MediaPlayer.OnCompletionListener() {
                        @Override
                        public void onCompletion(MediaPlayer mp) {

                            _pgCount.stop();
                            _pgCount.setBase(SystemClock.elapsedRealtime());

                            count = 0;
                            isPlaying = false;

                            _btnPlay.setBackground(ContextCompat.getDrawable(
                                    PostActivity.this, R.drawable.play));

                            _pgMusic.setProgress(0);
                            _pgMusic.setProgress(0);
                            _pgMusic.setProgress(0);
                        }
                    });
                }
            }
        });

    }

    private void cleanAttachment() {

        _attachBg.setVisibility(View.GONE);

        if ( _imageBg.getVisibility() == View.VISIBLE ){

            _postImage.setVisibility(View.GONE);
            _imageBg.setVisibility(View.GONE);
            _postImage.setImageDrawable(null);

        }
        else if ( _songBg.getVisibility() == View.VISIBLE ){

            _songBg.setVisibility(View.GONE);
            mPlayer.release();
            mPlayer = null;

        }
        else if ( _linkBg.getVisibility() == View.VISIBLE ){

            _linkBg.setVisibility(View.GONE);

            _postLinkImg.setImageDrawable(null);
            _imgHeader.setText("");
            src = null;

        }
    }

    private void initToolBar() {
        Toolbar mToolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(mToolbar);
        setTitle(getString(R.string.title_activity_post));
        mToolbar.setTitleTextColor(ContextCompat.getColor(this, R.color.white));
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.menu_post, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {

        int id = item.getItemId();

        if ( id == R.id.menu_attach_image ){

            if (  _songBg.getVisibility() == View.VISIBLE ||  _imageBg.getVisibility()
                    == View.VISIBLE || _linkBg.getVisibility() == View.VISIBLE ){

                Snackbar.make(findViewById(R.id.coordinatorLayout),
                        "Já existe um anexo em sua postagem, remova-o para anexar outro", Snackbar.LENGTH_LONG).show();
                return false;
            }

            adbuilder = new AlertDialog.Builder(PostActivity.this);
            adbuilder.setTitle("Adicionar imagem");
            adbuilder.setMessage(R.string.pick_image_method);

            adbuilder.setNegativeButton(R.string.cam, new DialogInterface.OnClickListener() {
                public void onClick(DialogInterface dialog, int which) {
                    try {
                        Intent captureIntent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
                        startActivityForResult(captureIntent, 1);
                    } catch (ActivityNotFoundException anfe) {
                        Toast toast = Toast.makeText(PostActivity.this, R.string.no_cam_error, Toast.LENGTH_SHORT);
                        toast.show();
                    }
                }
            });

            adbuilder.setPositiveButton(R.string.gallery, new DialogInterface.OnClickListener() {
                public void onClick(DialogInterface dialog, int which) {
                    try {
                        Intent i = new Intent(Intent.ACTION_PICK, MediaStore.Images.Media.EXTERNAL_CONTENT_URI);
                        startActivityForResult(i, 1);
                    } catch (ActivityNotFoundException anfe) {
                        Toast toast = Toast.makeText(PostActivity.this, R.string.gallery_error, Toast.LENGTH_SHORT);
                        toast.show();
                    }
                }
            });

            adbuilder.show();
        }
        else if ( id == R.id.menu_attach_music ){

            if (  _songBg.getVisibility() == View.VISIBLE ||  _imageBg.getVisibility()
                    == View.VISIBLE || _linkBg.getVisibility() == View.VISIBLE  ){

                Snackbar.make(findViewById(R.id.coordinatorLayout),
                        "Já existe um anexo em sua postagem, remova-o para anexar outro...", Snackbar.LENGTH_LONG).show();
                return false;
            }

            File path = new File( Environment.getExternalStorageDirectory().getAbsolutePath()
                    + getString(R.string.filepath) + "/" + u.getId() + "/" );

            File[] f = path.listFiles();
            List<String> lFiles = new ArrayList<>();

            if ( f != null )
                for (int i=0; i < f.length; i++)
                    lFiles.add(f[i].getName());

            if ( lFiles.size() > 0 ){

                final CharSequence[] items = lFiles.toArray(new CharSequence[lFiles.size()]);

                adbuilder = new AlertDialog.Builder(PostActivity.this);
                adbuilder.setTitle("Escolher o arquivo:")
                        .setItems(items, new DialogInterface.OnClickListener() {

                            public void onClick(DialogInterface dialog, int which) {

                                fileName = (String) items[which];
                                File path = new File( Environment.getExternalStorageDirectory().getAbsolutePath()
                                        + getString(R.string.filepath)  + "/" + u.getId() + "/" + fileName );

                                mPlayer = new MediaPlayer();
                                try {

                                    mPlayer.setDataSource(path.getPath());
                                    mPlayer.prepare();

                                    final int HOUR   = 60*60*1000;
                                    final int MINUTE = 60*1000;
                                    final int SECOND = 1000;

                                    int durationMin = ( mPlayer.getDuration() % HOUR ) / MINUTE;
                                    int durationSec = ( mPlayer.getDuration() % MINUTE ) / SECOND;

                                    _fileName.setText(fileName);

                                    _pgMusic.setProgress(0);
                                    _pgMusic.setMax( mPlayer.getDuration() / SECOND );
                                    _pgTot.setText(String.format("%02d:%02d", durationMin, durationSec ));

                                    _attachBg.setVisibility(View.VISIBLE);
                                    _songBg.setVisibility(View.VISIBLE);


                                } catch (IOException e) {
                                    Snackbar.make(findViewById(R.id.coordinatorLayout),
                                            "Erro ao abrir o arquivo " + fileName,
                                            Snackbar.LENGTH_LONG).show();
                                }

                            }
                        });
                adbuilder.show();

            }
            else {

                Snackbar.make(findViewById(R.id.coordinatorLayout),
                        "Não há nenhuma gravação para adicionar...", Snackbar.LENGTH_LONG).show();
                return false;

            }

        }
        else {
            PostActivity.this.finish();
        }
        return false;
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);

        if ( resultCode == Activity.RESULT_OK ) {

            String path;
            picUri = data.getData();

            if ( picUri != null ){

                String [] proj  = {MediaStore.Images.Media.DATA};
                Cursor cursor   = getContentResolver().query(picUri, proj, null, null, null);

                if (cursor.moveToFirst()){

                    int index = cursor.getColumnIndexOrThrow(MediaStore.Images.Media.DATA);
                    path = cursor.getString(index);

                    if ( path == null )
                        path = picUri.getPath();

                    if ( path != null ){

                        _attachBg.setVisibility(View.VISIBLE);
                        _postImage.setVisibility(View.VISIBLE);
                        _imageBg.setVisibility(View.VISIBLE);

                        _postImage.setImageBitmap(BitmapFactory.decodeFile(path));

                        int width  = _postImage.getDrawable().getIntrinsicWidth();
                        int height = _postImage.getDrawable().getIntrinsicHeight();

                        LinearLayout.LayoutParams params = (LinearLayout.LayoutParams) _postImage.getLayoutParams();

                        Display display = getWindowManager().getDefaultDisplay();
                        DisplayMetrics outMetrics = new DisplayMetrics();
                        display.getMetrics(outMetrics);

                        float dpWidth = outMetrics.widthPixels;

                        if ( height > width ) {

                            params.height = (int) (dpWidth * 0.9);
                            params.width = LinearLayout.LayoutParams.WRAP_CONTENT;

                        }
                        else {

                            params.height =  (int) (dpWidth * 0.5);
                            params.width  =  LinearLayout.LayoutParams.WRAP_CONTENT;

                        }

                        _postImage.setLayoutParams(params);

                    }
                }

                cursor.close();
            }
        }
    }

    private class FindAndAttachLink extends AsyncTask<String, Void, Void>{

        String header;
        ImageLoader imageLoader;

        @Override
        protected void onPostExecute(Void aVoid) {
            super.onPostExecute(aVoid);

            if ( _imageBg.getVisibility() != View.VISIBLE && _songBg.getVisibility() != View.VISIBLE ){

                if ( src != null && !src.isEmpty() ){

                    _attachBg.setVisibility(View.VISIBLE);
                    _linkBg.setVisibility(View.VISIBLE);

                    _postLinkImg.setImageUrl(src, imageLoader, PostActivity.this);
                    _imgHeader.setText(header);

                }
            }
        }

        @Override
        protected Void doInBackground(String... params) {

            try {

                imageLoader = AppController.getInstance().getImageLoader();

                String s = params[0];
                String url = "";

                if (s.startsWith("/"))
                    url = url + s;
                if (s.startsWith("http://"))
                    url = s;
                if (s.startsWith("www"))
                    url = "http://" + s;
                if ( !s.startsWith("www") && !s.startsWith("http://") && !s.startsWith("https://") )
                    url = "http://www." + s;


                Document doc = Jsoup.connect(url).userAgent("Chrome").get();

                Elements images = doc.select("div[style~=(?i)\\.(png|jpe?g)]");
                for ( Element img : images ) {

                    String imgUrl = img.attr("style");

                    String[] array = imgUrl.split("url");
                    if (array.length > 1) {
                        imgUrl = array[1];
                        array = imgUrl.split(" ");

                        for (String s1 : array) {
                            s1 = s1.replace("(", "");
                            s1 = s1.replace(")", "");
                            if (s1.endsWith(".png") || s1.endsWith(".jpg") || s1.endsWith(".jpeg")) {

                                imgUrl = s1;
                                if (imgUrl.startsWith("www"))
                                    src = "http://" + imgUrl;
                                else if ( imgUrl.contains("sscdn.") ) {

                                    String[] str = imgUrl.split("sscdn");
                                    src = "http://sscdn" + str[1];

                                }
                                else if (!imgUrl.startsWith("www") && !imgUrl.startsWith("http://") && !imgUrl.startsWith("https://"))
                                    src = url + imgUrl;
                                else
                                    src = imgUrl;

                                break;
                            }
                        }

                        if (src != null && !src.isEmpty())
                            break;
                    }
                }

                if ( src == null || src.isEmpty() ){

                    images = doc.select("img[src~=(?i)\\.(png|jpe?g)]");

                    for ( Element img : images ){

                        String imgUrl = img.attr("src");

                        int width = Integer.valueOf(img.attr("width").equals("") ? "0" : img.attr("width"));
                        int height = Integer.valueOf(img.attr("height").equals("") ? "0" : img.attr("height"));

                        if ( ( Patterns.WEB_URL.matcher(imgUrl).matches() && ( width >= 150 || height >= 150 ) ) ||
                             ( imgUrl.contains("sscdn.") && (width >= 150 || height >= 150) ) ||
                             ( width >= 150 && height >= 150 ) ) {

                            if (imgUrl.startsWith("www"))
                                src = "http://" + imgUrl;

                            else if ( imgUrl.contains("sscdn.") ) {
                                String[] str = imgUrl.split("sscdn");
                                src = "http://sscdn" + str[1];
                            }
                            else if ( !imgUrl.startsWith("www") &&
                                      !imgUrl.startsWith("http://") &&
                                      !imgUrl.startsWith("https://") &&
                                      !imgUrl.startsWith("/"))

                                src = "http://www" + imgUrl;

                            else if (imgUrl.startsWith("/"))
                                src = url + imgUrl;

                            else
                                src = imgUrl;

                            break;
                        }
                    }
                }

                if ( src != null && !src.isEmpty() ) {

                    Elements headers = doc.select("head");
                    for ( Element e : headers ){
                        String[] title = e.text().split("<title>");
                        title = title[0].split("<img");
                        header = title[0];
                    }
                }
            }
            catch (IOException e) {
                e.printStackTrace();
            }
            return null;
        }
    }

    @Override
    protected void onSaveInstanceState(Bundle outState){
        super.onSaveInstanceState(outState);
        outState.putSerializable("usuario", u);
    }

    @Override
    protected void onRestoreInstanceState(Bundle savedInstanceState) {
        super.onRestoreInstanceState(savedInstanceState);
        u = (Usuario)savedInstanceState.getSerializable("usuario");
        ((AppController)this.getApplication()).setUsuario(u);
    }

    @Override
    protected void onResume() {
        super.onResume();
        if ( ((AppController) this.getApplication()).getListInstType() == null ||
                ((AppController) this.getApplication()).getListInstType().isEmpty() )
            ((AppController) this.getApplication()).instantiateInstList(this);
    }
}
