package tads.ufpr.pr.br.backstage;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.ActivityNotFoundException;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.provider.MediaStore;
import android.support.design.widget.AppBarLayout;
import android.support.design.widget.CollapsingToolbarLayout;
import android.support.design.widget.CoordinatorLayout;
import android.support.design.widget.FloatingActionButton;
import android.support.design.widget.Snackbar;
import android.support.design.widget.TabLayout;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentManager;
import android.support.v4.app.FragmentStatePagerAdapter;
import android.support.v4.content.ContextCompat;
import android.support.v4.view.ViewPager;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.text.Spannable;
import android.text.SpannableString;
import android.text.style.ImageSpan;
import android.util.Base64;
import android.util.DisplayMetrics;
import android.view.Display;
import android.view.Menu;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.View;
import android.widget.ImageView;
import android.widget.Toast;

import org.apache.http.HttpResponse;
import org.apache.http.HttpVersion;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpDelete;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.conn.ClientConnectionManager;
import org.apache.http.conn.scheme.PlainSocketFactory;
import org.apache.http.conn.scheme.Scheme;
import org.apache.http.conn.scheme.SchemeRegistry;
import org.apache.http.conn.ssl.SSLSocketFactory;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.impl.conn.tsccm.ThreadSafeClientConnManager;
import org.apache.http.params.BasicHttpParams;
import org.apache.http.params.HttpProtocolParams;
import org.apache.http.protocol.HTTP;

import java.security.KeyStore;
import java.util.ArrayList;
import java.util.List;

import Util.DatabaseHandler;
import Util.MySSLSocketFactory;
import Util.UpdateInstruments;
import Util.UpdateProfile;
import Util.Utils;

import static android.view.View.INVISIBLE;
import static android.view.View.OnClickListener;
import static org.apache.http.params.HttpConnectionParams.setConnectionTimeout;
import static org.apache.http.params.HttpConnectionParams.setSoTimeout;

@SuppressWarnings("All")
public class ProfileActivity extends AppCompatActivity {

    private static final int IMAGE_PICKER = 100;
    private static final int CROP_IMAGE   = 200;
    private static final int INSTRUMENTOS = 300;
    private static final int PERFIL       = 400;
    private static final int PREFERENCIAS = 500;
    private static final int CHAT         = 600;

    Usuario u;
    Uri picUri;
    boolean isUser;
    Toolbar toolbar;
    ImageView ivUser;
    AppBarLayout appbar;
    CoordinatorLayout cl;
    ViewPagerAdapter adapter;
    AlertDialog.Builder adbuilder;
    DatabaseHandler databaseHandler;
    CollapsingToolbarLayout collapsingToolbar;

    private int[] imageResId = {
            R.drawable.user,
            R.drawable.feed_icon
    };

    @Override
    protected void onCreate(Bundle inState) {
        super.onCreate(inState);
        setContentView(R.layout.activity_profile);
        cl = (CoordinatorLayout) findViewById(R.id.coordinatorLayout);

        u = new Usuario();

        Bundle extras = getIntent().getExtras();
        if (extras != null){

            u = (Usuario)extras.getSerializable("user");
            if ( u == null ){

                isUser = true;
                u  = ((AppController)this.getApplication()).getUsuario();

            }

        }
        else {
            isUser = true;
            u  = ((AppController)this.getApplication()).getUsuario();
        }

        databaseHandler = new DatabaseHandler(this);

        initToolbar();
        initViewPagerAndTabs();

        ivUser = (ImageView)findViewById(R.id.backdrop);

        if ( u != null && u.getImagem() != null ) {
            ivUser.setImageBitmap(Utils.string2Bitmap(u.getImagem()));
        }

        ivUser.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                if (isUser) {

                    adbuilder = new AlertDialog.Builder(ProfileActivity.this);
                    adbuilder.setTitle(R.string.pick_image);
                    adbuilder.setMessage(R.string.pick_image_method);
                    adbuilder.setIcon(R.drawable.cam);

                    adbuilder.setNegativeButton(R.string.cam, new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialog, int which) {
                            try {
                                ((AppController) ProfileActivity.this.getApplication()).setAction(true);
                                Intent captureIntent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
                                startActivityForResult(captureIntent, IMAGE_PICKER);
                            } catch (ActivityNotFoundException anfe) {
                                Toast toast = Toast.makeText(ProfileActivity.this, R.string.no_cam_error, Toast.LENGTH_SHORT);
                                toast.show();
                            }
                        }
                    });

                    adbuilder.setPositiveButton(R.string.gallery, new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialog, int which) {
                            try {
                                //Intent padrão para seleção de imagens na galeria
                                ((AppController) ProfileActivity.this.getApplication()).setAction(true);
                                Intent i = new Intent(Intent.ACTION_PICK, MediaStore.Images.Media.EXTERNAL_CONTENT_URI);
                                startActivityForResult(i, IMAGE_PICKER);
                            } catch (ActivityNotFoundException anfe) {
                                Toast toast = Toast.makeText(ProfileActivity.this, R.string.gallery_error, Toast.LENGTH_SHORT);
                                toast.show();
                            }
                        }
                    });
                    adbuilder.show();
                }
            }
        });
    }

    @Override
    protected void onResume() {
        super.onResume();

        if (  ((AppController) ProfileActivity.this.getApplication()).isUpdated() ){

            ((AppController) ProfileActivity.this.getApplication()).setUpdated(false);
            Handler handler = new Handler();
            handler.postDelayed(new Runnable() {
                @Override
                public void run() {

                    Snackbar.make(cl, getResources().getString(R.string.profile_updated),
                            Snackbar.LENGTH_LONG).show();

                }
            }, 820);

        }


        if ( ((AppController) ProfileActivity.this.getApplication()).isUpdatedError() ){

            ((AppController) ProfileActivity.this.getApplication()).setUpdatedError(false);
            Handler handler = new Handler();
            handler.postDelayed(new Runnable() {
                @Override
                public void run() {

                    Snackbar.make(cl, getResources().getString(R.string.no_network_text),
                            Snackbar.LENGTH_LONG).show();

                }
            }, 820);

        }
    }

    private void initToolbar() {

        toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);

        Display display = getWindowManager().getDefaultDisplay();
        DisplayMetrics outMetrics = new DisplayMetrics();
        display.getMetrics(outMetrics);
        int dpHeight  = outMetrics.widthPixels;

        appbar = (AppBarLayout)findViewById(R.id.appbar);

        CoordinatorLayout.LayoutParams params = (CoordinatorLayout.LayoutParams) appbar.getLayoutParams();
        params.height = dpHeight;

        collapsingToolbar = (CollapsingToolbarLayout) findViewById(R.id.collapsing_toolbar);

        if ( u.getDtNasc() != null && !u.getDtNasc().isEmpty() )
            collapsingToolbar.setTitle(u.getNome() + ", " + Utils.calcAge(u.getDtNasc()));
        else
            collapsingToolbar.setTitle(u.getNome());

        collapsingToolbar.setOnTouchListener(new View.OnTouchListener() {
            @Override
            public boolean onTouch(View v, MotionEvent event) {

                collapsingToolbar.setTitle(u.getNome() + ", " + Utils.calcAge(u.getDtNasc()));
                return true;
            }
        });
    }

    private void initViewPagerAndTabs() {

        ViewPager viewPager = (ViewPager) findViewById(R.id.viewPager);
        adapter =  new ViewPagerAdapter(getSupportFragmentManager(), 2);
        viewPager.setAdapter(adapter);

        TabLayout tabLayout = (TabLayout) findViewById(R.id.tabLayout);
        tabLayout.setupWithViewPager(viewPager);

        tabLayout.getTabAt(0).setText(getPageTitle(0));
        tabLayout.getTabAt(1).setText(getPageTitle(1));

        FloatingActionButton fab = (FloatingActionButton)findViewById(R.id.fabButton);

        if(isUser)
            fab.setVisibility(INVISIBLE);
        else
            fab.setImageDrawable(ContextCompat.getDrawable(this, R.drawable.message_icon48));

        fab.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {
                //Tela de Chat
                Intent i = new Intent(ProfileActivity.this, ChatActivity.class);
                i.putExtra("person", u);
                startActivityForResult(i, CHAT);
            }
        });
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {

        if ( resultCode == Activity.RESULT_OK ) {

            switch (requestCode) {

                case IMAGE_PICKER:

                    picUri = data.getData();
                    doCrop();
                    break;

                case CROP_IMAGE:

                    Bundle extras = data.getExtras();
                    Bitmap thePic = extras.getParcelable("data");
                    ivUser.setImageBitmap(thePic);
                    u.setImagem(Utils.bitmap2String(thePic));

                    ((AppController)this.getApplication()).setUsuario(u);

                    if ( Utils.isNetworkOnline(this) )

                        new UpdateProfile(u, this).execute();

                    else{

                        DatabaseHandler db = new DatabaseHandler(this);
                        u = db.getUser();
                        ((AppController)this.getApplication()).setUsuario(u);

                        ((AppController) ProfileActivity.this.getApplication()).setUpdatedError(true);
                        Intent i = new Intent(this, ProfileActivity.class);
                        startActivity(i);
                        finish();
                        overridePendingTransition(R.animator.mainfadein, R.animator.splashfadeout);

                    }

                    break;

                case PREFERENCIAS:
                case PERFIL:

                    if ( Utils.isNetworkOnline(this))

                        new UpdateProfile(u, this).execute();

                    else{

                        DatabaseHandler db = new DatabaseHandler(this);
                        u = db.getUser();
                        ((AppController)this.getApplication()).setUsuario(u);

                        ((AppController) ProfileActivity.this.getApplication()).setUpdatedError(true);
                        Intent i = new Intent(this, ProfileActivity.class);
                        startActivity(i);
                        finish();
                        overridePendingTransition(R.animator.mainfadein, R.animator.splashfadeout);

                    }

                    break;

                case INSTRUMENTOS:

                    if ( Utils.isNetworkOnline(this) )

                        new UpdateInstruments(u, this).execute();

                    else{

                        DatabaseHandler db = new DatabaseHandler(this);
                        u = db.getUser();
                        ((AppController)this.getApplication()).setUsuario(u);

                        ((AppController) ProfileActivity.this.getApplication()).setUpdatedError(true);
                        Intent i = new Intent(this, ProfileActivity.class);
                        startActivity(i);
                        finish();
                        overridePendingTransition(R.animator.mainfadein, R.animator.splashfadeout);
                    }

                    break;
            }
        }
        else{
            if ( isUser ){
                DatabaseHandler db = new DatabaseHandler(this);
                u = db.getUser();
                ((AppController)this.getApplication()).setUsuario(u);
                Intent i = new Intent(this, ProfileActivity.class);
                startActivity(i);
                finish();
            }
            else if ( requestCode == CHAT ){

                Intent i = new Intent(this, ProfileActivity.class);
                i.putExtra("user", u);
                startActivity(i);
                finish();

            }
        }

    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {

        if ( !isUser ){

            if ( databaseHandler.isFriend(u) )
                getMenuInflater().inflate(R.menu.menu_remove_friend, menu);
            else
                getMenuInflater().inflate(R.menu.menu_add_friend, menu);

        }

        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {

        int id = item.getItemId();

        if ( id == R.id.menu_add_friend ){

            adbuilder = new AlertDialog.Builder(this);
            adbuilder.setTitle("Seguir " + u.getNome() + "?");
            adbuilder.setMessage("Deseja seguir " + u.getNome() + "? Você passará a receber atualizações em seu feed...");
            adbuilder.setPositiveButton("Sim", new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface dialog, int which) {

                    if (Utils.isNetworkOnline(ProfileActivity.this)) {

                        new UpdateFriends(ProfileActivity.this, 1, ((AppController) ProfileActivity.this
                                .getApplication()).getUsuario(), u).execute();

                        dialog.cancel();
                        dialog.dismiss();

                    } else {

                        Snackbar.make(cl, "Sem conexão com a intermet. Por favor, " +
                                "tente novamente mais tarde.", Snackbar.LENGTH_LONG).show();

                    }
                }
            });

            adbuilder.setNegativeButton("Não", new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface dialog, int which) {
                    dialog.cancel();
                    dialog.dismiss();
                }
            });

            adbuilder.show();

        }
        else if ( id == R.id.menu_unfriend ){

            adbuilder = new AlertDialog.Builder(this);
            adbuilder.setTitle("Deixar de seguir " + u.getNome() + "?");
            adbuilder.setMessage("Deseja deixar de seguir " + u.getNome() + "? Você deixará de receber atualizações em seu feed...");
            adbuilder.setPositiveButton("Sim", new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface dialog, int which) {

                    if (Utils.isNetworkOnline(ProfileActivity.this)) {

                        new UpdateFriends(ProfileActivity.this, 2, ((AppController) ProfileActivity.this
                                .getApplication()).getUsuario(), u).execute();

                        dialog.cancel();
                        dialog.dismiss();

                    } else {

                        Snackbar.make(cl, "Sem conexão com a intermet. Por favor, " +
                                "tente novamente mais tarde.", Snackbar.LENGTH_LONG).show();

                    }
                }
            });

            adbuilder.setNegativeButton("Não", new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface dialog, int which) {
                    dialog.cancel();
                    dialog.dismiss();
                }
            });

            adbuilder.show();
        }
        else
            finish();

        return super.onOptionsItemSelected(item);
    }

    @Override
    protected void onSaveInstanceState(Bundle outState){
        super.onSaveInstanceState(outState);
        outState.putSerializable("usuario", u);
    }

    @Override
    protected void onRestoreInstanceState(Bundle savedInstanceState) {
        super.onRestoreInstanceState(savedInstanceState);

        if ( !((AppController) ProfileActivity.this.getApplication()).isAction() ){

            u = (Usuario)savedInstanceState.getSerializable("usuario");
            Intent i = new Intent(this, ProfileActivity.class);

            if ( isUser )
                ((AppController)this.getApplication()).setUsuario(u);
            else
                i.putExtra("user", u);

            startActivity(i);
            finish();
        }
        else
            ((AppController) ProfileActivity.this.getApplication()).setAction(false);

    }

    public void editClick(View v){

        if ( isUser ) {

            switch (v.getId()) {

                case R.id.cv_profile_import:

                    ((AppController) ProfileActivity.this.getApplication()).setAction(true);
                    Intent i = new Intent(ProfileActivity.this, EditActivity.class);
                    i.putExtra("user", u);
                    i.putExtra("action", PERFIL);
                    startActivityForResult(i, PERFIL);
                    break;

                case R.id.cv_instrumentos_import:

                    ((AppController) ProfileActivity.this.getApplication()).setAction(true);
                    i = new Intent(ProfileActivity.this, EditActivity.class);
                    i.putExtra("user", u);
                    i.putExtra("action", INSTRUMENTOS);
                    startActivityForResult(i, INSTRUMENTOS);
                    break;

                case R.id.cv_preference_import:

                    ((AppController) ProfileActivity.this.getApplication()).setAction(true);
                    adbuilder = new AlertDialog.Builder(this);
                    adbuilder.setTitle(getString(R.string.choose_preferences_edit))
                        .setItems(R.array.preferences_array, new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog, int which) {

                                Intent i = new Intent(ProfileActivity.this, EditActivity.class);
                                i.putExtra("user", u);
                                i.putExtra("action", PREFERENCIAS);

                                if (which == 0){
                                    i.putExtra("preference", getString(R.string.style));
                                }
                                else{
                                    i.putExtra("preference", getString(R.string.influence));
                                }
                                startActivityForResult(i, PREFERENCIAS);
                            }
                        });
                    adbuilder.show();
                    break;
            }
        }
    }

    private void doCrop() {

        try {

            //Ação padrão para corte em Imagens ( alguns dispositivos antigos não suportam )
            Intent cropIntent = new Intent("com.android.camera.action.CROP");
            cropIntent.setDataAndType(picUri, "image/*");
            cropIntent.putExtra("crop", "true");
            cropIntent.putExtra("aspectX", 1);
            cropIntent.putExtra("aspectY", 1);

            //Indica a resuloção do corte - 256 é leve o bastante p/ REST
            cropIntent.putExtra("outputX", 256);
            cropIntent.putExtra("outputY", 256);
            cropIntent.putExtra("return-data", true);

            ((AppController) ProfileActivity.this.getApplication()).setAction(true);
            startActivityForResult(cropIntent, CROP_IMAGE);

        }
        catch(ActivityNotFoundException anfe){

            Snackbar.make(cl, R.string.crop_image_error, Snackbar.LENGTH_LONG).show();

        }

    }

    public CharSequence getPageTitle(int tab) {
        Drawable image = ContextCompat.getDrawable(this, imageResId[tab]);
        int tb = Utils.getTabsHeight(this);
        tb -= tb * 0.5;
        image.setBounds(0, 0, tb, tb);
        SpannableString sb = new SpannableString(" ");
        ImageSpan imageSpan = new ImageSpan(image, ImageSpan.ALIGN_BOTTOM);
        sb.setSpan(imageSpan, 0, 1, Spannable.SPAN_EXCLUSIVE_EXCLUSIVE);
        return sb;
    }

    public class ViewPagerAdapter extends FragmentStatePagerAdapter {

        CharSequence Titles[];
        int NumbOfTabs;

        public ViewPagerAdapter(FragmentManager fm, int mNumbOfTabsumb) {
            super(fm);
            this.NumbOfTabs = mNumbOfTabsumb;
            List<CharSequence> listItems = new ArrayList<>();
            listItems.add("Profile");
            listItems.add("UserFeed");
            this.Titles = listItems.toArray(new CharSequence[listItems.size()]);
        }

        @Override
        public Fragment getItem(int position) {

            if(position == 0)
                return ProfileFragment.createInstance(u);
            else
                return new NewsFeed();
        }

        @Override
        public CharSequence getPageTitle(int position) {
            return Titles[position];
        }

        @Override
        public int getCount() { return NumbOfTabs; }

        @Override
        public int getItemPosition(Object object) {
            return POSITION_NONE;
        }

        @Override
        public void notifyDataSetChanged() {
            super.notifyDataSetChanged();
        }

    }

    public class UpdateFriends extends AsyncTask<Void, Void, Void> {

        int option;
        Usuario me;
        Usuario usuario;
        Activity activity;
        HttpResponse response;
        ProgressDialog progressDialog;

        public UpdateFriends(Activity activity, int option, Usuario me, Usuario usuario){
            this.me = me;
            this.option = option;
            this.usuario = usuario;
            this.activity = activity;
        }

        @Override
        protected void onPreExecute() {

            if ( option == 1 || option == 2 ){

                progressDialog = new ProgressDialog(activity, R.style.AppTheme_Dark_Dialog);
                progressDialog.setIndeterminate(true);
                progressDialog.setCancelable(false);

                if ( option == 1 )
                    progressDialog.setMessage("Seguindo " + usuario.getNome() + "..." );

                else
                    progressDialog.setMessage("Deixando de seguir " + usuario.getNome() + "..." );

                progressDialog.show();

            }

            super.onPreExecute();
        }

        @Override
        protected void onPostExecute(Void aVoid) {
            super.onPostExecute(aVoid);

            if ( option == 1 ){

                progressDialog.dismiss();
                progressDialog.cancel();

                if ( response.getStatusLine().getStatusCode() == 201 ){

                    databaseHandler.addFriend(u);

                    adbuilder = new AlertDialog.Builder(activity, R.style.AppTheme_Dark_Dialog);
                    adbuilder.setMessage("Agora você está seguindo " + usuario.getNome() );
                    adbuilder.setPositiveButton("Ok", new DialogInterface.OnClickListener() {

                        @Override
                        public void onClick(DialogInterface dialog, int which) {

                            Intent i = new Intent(ProfileActivity.this, ProfileActivity.class);
                            i.putExtra("user", usuario);
                            startActivity(i);
                            activity.finish();
                            overridePendingTransition(R.animator.mainfadein, R.animator.splashfadeout);

                        }
                    });

                    adbuilder.show();

                }

            }
            else if ( option == 2 ){

                progressDialog.dismiss();
                progressDialog.cancel();

                int result = response.getStatusLine().getStatusCode();

                if ( result == 204 ){

                    databaseHandler.deleteFriend(u);

                    adbuilder = new AlertDialog.Builder(activity, R.style.AppTheme_Dark_Dialog);
                    adbuilder.setMessage("Você deixou de seguir " + usuario.getNome() );
                    adbuilder.setPositiveButton("Ok", new DialogInterface.OnClickListener() {

                        @Override
                        public void onClick(DialogInterface dialog, int which) {

                            Intent i = new Intent(ProfileActivity.this, ProfileActivity.class);
                            i.putExtra("user", usuario);
                            startActivity(i);
                            activity.finish();
                            overridePendingTransition(R.animator.mainfadein, R.animator.splashfadeout);

                        }
                    });

                    adbuilder.show();

                }
            }
        }

        @Override
        protected Void doInBackground(Void... params) {

            HttpClient httpclient = null;

            BasicHttpParams httpParams = new BasicHttpParams();
            setConnectionTimeout(httpParams, 3000);
            setSoTimeout(httpParams, 5000);

            try {

                KeyStore trustStore = KeyStore.getInstance(KeyStore.getDefaultType());
                trustStore.load(null, null);

                MySSLSocketFactory sf = new MySSLSocketFactory(trustStore);
                sf.setHostnameVerifier(SSLSocketFactory.ALLOW_ALL_HOSTNAME_VERIFIER);

                HttpProtocolParams.setVersion(httpParams, HttpVersion.HTTP_1_1);
                HttpProtocolParams.setContentCharset(httpParams, HTTP.UTF_8);

                SchemeRegistry registry = new SchemeRegistry();
                registry.register(new Scheme("http", PlainSocketFactory.getSocketFactory(), 80));
                registry.register(new Scheme("https", sf, 443));

                ClientConnectionManager ccm = new ThreadSafeClientConnManager(httpParams, registry);

                httpclient = new DefaultHttpClient(ccm, httpParams);

                httpclient = new DefaultHttpClient(httpParams);

            }
            catch (Exception e) { e.printStackTrace(); }

            if ( option == 1 ){

                try {

                    String url = activity.getString(R.string.server_address) + "/usuario/"
                            + me.getId() + "/seguir/" + usuario.getId();


                    HttpPost httpPost = new HttpPost(url);

                    String user = activity.getString(R.string.server_user);
                    String basicAuth = "Basic " + Base64.encodeToString(user.getBytes(), Base64.NO_WRAP);
                    httpPost.setHeader("Authorization", basicAuth);
                    httpPost.setHeader(HTTP.CONTENT_TYPE, "application/x-www-form-urlencoded; charset=UTF-8");

                    response = httpclient.execute(httpPost);

                    httpPost.abort();

                }
                catch (Exception e) { e.printStackTrace(); }

            }
            else if ( option == 2 ){

                try {

                    String url = activity.getString(R.string.server_address) + "/usuario/"
                            + me.getId() + "/seguir/" + usuario.getId();

                    HttpDelete httpDelete = new HttpDelete(url);

                    String user = activity.getString(R.string.server_user);
                    String basicAuth = "Basic " + Base64.encodeToString(user.getBytes(), Base64.NO_WRAP);
                    httpDelete.setHeader("Authorization", basicAuth);
                    httpDelete.setHeader(HTTP.CONTENT_TYPE, "application/x-www-form-urlencoded; charset=UTF-8");

                    response = httpclient.execute(httpDelete);

                    httpDelete.abort();
                }
                catch (Exception e) { e.printStackTrace(); }
            }

            return null;
        }
    }
}
