package tads.ufpr.pr.br.backstage;

import android.app.DialogFragment;
import android.content.Context;
import android.os.Bundle;
import android.os.SystemClock;
import android.os.Vibrator;
import android.support.design.widget.FloatingActionButton;
import android.util.DisplayMetrics;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.Window;
import android.widget.Chronometer;
import android.widget.ImageView;
import android.widget.ProgressBar;

import butterknife.ButterKnife;
import butterknife.InjectView;

public class RecordDialog extends DialogFragment {

    @InjectView(R.id.progress_bar)   ProgressBar          _pgBar;
    @InjectView(R.id.btnSave)        ImageView            _btnSave;
    @InjectView(R.id.btnDiscard)     ImageView            _btnDiscard;
    @InjectView(R.id.progress_clock)
    Chronometer _pgClock;
    @InjectView(R.id.rec)            FloatingActionButton _btnRec;

    private static int STATUS_INACTIVE  = 100;
    private static int STATUS_RECORDING = 200;
    private static int STATUS_STOPED    = 300;
    private static int STATUS_PLAYING   = 400;

    private int status;

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        View rootView = inflater.inflate(R.layout.record_layout, container, false);

        getDialog().getWindow().requestFeature(Window.FEATURE_NO_TITLE);
        getDialog().setCanceledOnTouchOutside(false);

        ButterKnife.inject(this, rootView);

        status = STATUS_INACTIVE;

        _pgBar.setMax(61);
        _pgBar.setProgress(0);

        _btnSave.setOnClickListener(click);
        _btnDiscard.setOnClickListener(click);
        _btnRec.setOnClickListener(click);

        _pgClock.setOnChronometerTickListener(new Chronometer.OnChronometerTickListener() {
            @Override
            public void onChronometerTick(Chronometer chronometer) {
                _pgBar.setProgress( _pgBar.getProgress() + 1 );
            }
        });

        return rootView;
    }

    @Override
    public void onStart() {
        super.onStart();

        if (getDialog() == null) {
            return;
        }

        DisplayMetrics dm = new DisplayMetrics();
        getDialog().getWindow().getWindowManager().getDefaultDisplay().getMetrics(dm);
        getDialog().getWindow().setLayout((int) (dm.widthPixels * .90), (int) (dm.heightPixels * .60));

    }

    View.OnClickListener click = new View.OnClickListener() {
        @Override
        public void onClick(View v) {

            Vibrator vb = (Vibrator) getActivity().getSystemService(Context.VIBRATOR_SERVICE);
            vb.vibrate(050);

            switch ( v.getId() ){

                case R.id.btnSave:

                    break;

                case R.id.btnDiscard:

                    break;

                case R.id.rec:

                    recordOptions();
                    break;
            }
        }
    };

    private void recordOptions() {

        _pgClock.setBase(SystemClock.elapsedRealtime());
        _pgClock.start();
    }
}
