package tads.ufpr.pr.br.backstage;

import android.app.Activity;
import android.content.Context;
import android.support.v7.widget.RecyclerView;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import com.android.volley.toolbox.ImageLoader;

import java.util.List;

public class RecyclerAdapter extends RecyclerView.Adapter<RecyclerView.ViewHolder> {

    private final int AUDIO = 4;

    private List<Post> lPost;
    private Activity activity;
    private LayoutInflater inflater;

    ImageLoader imageLoader = AppController.getInstance().getImageLoader();

    public RecyclerAdapter(Activity activity, List<Post> lPost) {
        this.lPost = lPost;
        this.activity = activity;
    }

    @Override
    public int getItemViewType(int position) {

        if ( lPost.get(position).getPostType() == AUDIO )
            return 1;
        else
            return 0;

    }

    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {

        View v1;
        if (inflater == null)
            inflater = (LayoutInflater) activity
                    .getSystemService(Context.LAYOUT_INFLATER_SERVICE);

        if (imageLoader == null)
            imageLoader = AppController.getInstance().getImageLoader();

        if ( viewType == 1 )// Audio Layout
            v1 = inflater.inflate(R.layout.view_holder2, parent, false);

        else //Normal Layout
            v1 = inflater.inflate(R.layout.view_holder1, parent, false);


        return new ItemViewHolder(v1, activity);
    }

    @Override
    public void onBindViewHolder(RecyclerView.ViewHolder viewHolder, int position) {

        switch (getItemViewType(position)){

            case 0:

                ItemViewHolder.bindHolder1((ItemViewHolder)viewHolder, lPost.get(position));
                break;

            case 1:

                ItemViewHolder.bindHolder2((ItemViewHolder)viewHolder, lPost.get(position));
                break;

        }

    }

    @Override
    public int getItemCount() {
        return lPost == null ? 0 : lPost.size();
    }

}