package tads.ufpr.pr.br.backstage;

import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentManager;
import android.support.v4.app.FragmentStatePagerAdapter;
import android.support.v4.content.ContextCompat;
import android.support.v4.view.ViewPager;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.text.Spannable;
import android.text.SpannableString;
import android.text.style.ImageSpan;
import android.view.MenuItem;

import Util.Utils;

public class ResultSearchActivity extends AppCompatActivity {

    private int[] imageResId = {
        R.drawable.friends_icon,
        R.drawable.feed_icon,
    };

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_result_search);


        Toolbar mToolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(mToolbar);
        setTitle(getString(R.string.app_name));
        mToolbar.setTitleTextColor(ContextCompat.getColor(this, R.color.white));
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);

        ViewPager viewPager = (ViewPager) findViewById(R.id.viewPager);
        ViewPagerAdapter adapter =  new ViewPagerAdapter(getSupportFragmentManager(), 1);
        viewPager.setAdapter(adapter);

        //TabLayout tabLayout = (TabLayout) findViewById(R.id.tabLayout);
        //tabLayout.setupWithViewPager(viewPager);

        //tabLayout.getTabAt(0).setText(getPageTitle(0));
        //tabLayout.getTabAt(1).setText(getPageTitle(1));

    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        finish();
        return super.onOptionsItemSelected(item);
    }

    public CharSequence getPageTitle(int tab) {
        Drawable image = ContextCompat.getDrawable(this, imageResId[tab]);

        int tb = Utils.getTabsHeight(this);
        tb -= tb * 0.5;

        image.setBounds(0, 0, tb, tb);
        SpannableString sb = new SpannableString(" ");
        ImageSpan imageSpan = new ImageSpan(image, ImageSpan.ALIGN_BOTTOM);
        sb.setSpan(imageSpan, 0, 1, Spannable.SPAN_EXCLUSIVE_EXCLUSIVE);
        return sb;
    }

    public class ViewPagerAdapter extends FragmentStatePagerAdapter {

        int NumbOfTabs;

        public ViewPagerAdapter(FragmentManager fm, int mNumbOfTabsumb) {
            super(fm);
            this.NumbOfTabs = mNumbOfTabsumb;
        }

        @Override
        public Fragment getItem(int position) {

            return new ResultUserFragment();

        }

        @Override
        public int getCount() {
            return NumbOfTabs;
        }
    }
}
