package tads.ufpr.pr.br.backstage;

import android.os.AsyncTask;
import android.os.Bundle;
import android.support.annotation.Nullable;
import android.support.v4.app.Fragment;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.util.Base64;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import org.apache.http.HttpResponse;
import org.apache.http.HttpVersion;
import org.apache.http.NameValuePair;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.utils.URLEncodedUtils;
import org.apache.http.conn.ClientConnectionManager;
import org.apache.http.conn.scheme.PlainSocketFactory;
import org.apache.http.conn.scheme.Scheme;
import org.apache.http.conn.scheme.SchemeRegistry;
import org.apache.http.conn.ssl.SSLSocketFactory;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.impl.conn.tsccm.ThreadSafeClientConnManager;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.params.BasicHttpParams;
import org.apache.http.params.HttpProtocolParams;
import org.apache.http.protocol.HTTP;
import org.apache.http.util.EntityUtils;
import org.json.JSONArray;
import org.json.JSONObject;
import java.net.URLDecoder;
import java.security.KeyStore;
import java.util.ArrayList;
import java.util.LinkedHashSet;
import java.util.LinkedList;
import java.util.List;

import Util.MySSLSocketFactory;

import static org.apache.http.params.HttpConnectionParams.setConnectionTimeout;
import static org.apache.http.params.HttpConnectionParams.setSoTimeout;

@SuppressWarnings("All")
public class ResultUserFragment extends Fragment {

    View v;
    Usuario me;
    String text;
    Bundle extras;
    List<Usuario> lUsers;
    UsersListAdapter ulad;
    RecyclerView _recView;
    Instrumento instrumento;
    boolean executando, first;
    int option, dist, offset, type, level;
    EndlessRecyclerOnScrollListener scrollListener;

    @Override
    public View onCreateView(LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {

        v = inflater.inflate(R.layout.generic_recycler_view_frag, container, false);
        _recView = (RecyclerView)v.findViewById(R.id.recyclerView);
        lUsers = new ArrayList<>();
        me = ((AppController)getActivity().getApplication()).getUsuario();

        first = true;

        extras = getActivity().getIntent().getExtras();
        if ( extras != null ){
            option = extras.getInt("option");
            text   = extras.getString("text");
            dist   = extras.getInt("dist");
            type   = extras.getInt("type");
            level  = extras.getInt("level");
            instrumento = (Instrumento)extras.getSerializable("inst");
        }

        ulad = new UsersListAdapter(lUsers, me);
        ulad.setActivity(getActivity());
        _recView.setAdapter(ulad);

        LinearLayoutManager llm = new LinearLayoutManager(getActivity());
        _recView.setLayoutManager(llm);
        _recView.setHasFixedSize(true);

        FetchUserData fud = new FetchUserData();
        fud.execute();

        scrollListener = new EndlessRecyclerOnScrollListener(llm) {
            @Override
            public void onLoadMore(int offset2) {

                if ( !executando ) {
                    offset = lUsers.size();
                    FetchUserData fud = new FetchUserData();
                    fud.execute();
                }

            }
        };

        _recView.addOnScrollListener(scrollListener);

        return v;
    }

    private class FetchUserData extends AsyncTask<Void, Void, Void> {

        String url;
        HttpGet httpGet;
        HttpResponse response;
        private Exception exceptionToBeThrown;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

            (v.findViewById(R.id.loading)).setVisibility(View.VISIBLE);

            if ( option == 1 ){ //Texto

                url = getString( R.string.server_address ) + "/busca/usuario/" + text + "?";

                List<NameValuePair> params = new LinkedList<>();
                params.add(new BasicNameValuePair("id", String.valueOf(me.getId())));
                params.add(new BasicNameValuePair("offset", String.valueOf(offset)));
                params.add(new BasicNameValuePair("dist", String.valueOf(dist)));
                String paramString = URLEncodedUtils.format(params,  HTTP.UTF_8);
                url += paramString;

                url = url.replace(" ", "%20");

            }
            else if ( option == 2 ){ //Instrumento

                url = getString( R.string.server_address ) + "/busca/usuario/instrumento/"
                        + instrumento.getInstId() + "/nivel/" + level + "?";

                List<NameValuePair> params = new LinkedList<>();
                params.add(new BasicNameValuePair("id", String.valueOf(me.getId())));
                params.add(new BasicNameValuePair("dist", String.valueOf(dist)));
                String paramString = URLEncodedUtils.format(params,  HTTP.UTF_8);
                url += paramString;

            }
            else if ( option == 3 ) { //Texto e Instrumento

                url = getString( R.string.server_address ) + "/busca/usuario/" + text + "?";
                List<NameValuePair> params = new LinkedList<>();
                params.add(new BasicNameValuePair("id", String.valueOf(me.getId())));
                params.add(new BasicNameValuePair("inst", String.valueOf(instrumento.getInstId())));
                params.add(new BasicNameValuePair("level", String.valueOf(level)));
                params.add(new BasicNameValuePair("dist", String.valueOf(dist)));
                String paramString = URLEncodedUtils.format(params,  HTTP.UTF_8);
                url += paramString;

            }
            else if ( option == 4 ){ //Distância

                url = getString( R.string.server_address ) + "/busca/usuario/distancia/" + dist + "?";

                List<NameValuePair> params = new LinkedList<>();
                params.add(new BasicNameValuePair("id", String.valueOf(me.getId())));
                params.add(new BasicNameValuePair("offset", String.valueOf(offset)));
                String paramString = URLEncodedUtils.format(params,  HTTP.UTF_8);
                url += paramString;

            }

            httpGet = new HttpGet(url);
            String user = getResources().getString(R.string.server_user);
            String basicAuth = "Basic " + Base64.encodeToString(user.getBytes(), Base64.NO_WRAP);
            httpGet.setHeader("Authorization", basicAuth);

            executando = true;
        }

        @Override
        protected Void doInBackground(Void... params) {

            try{

                KeyStore trustStore = KeyStore.getInstance(KeyStore.getDefaultType());
                trustStore.load(null, null);

                MySSLSocketFactory sf = new MySSLSocketFactory(trustStore);
                sf.setHostnameVerifier(SSLSocketFactory.ALLOW_ALL_HOSTNAME_VERIFIER);

                BasicHttpParams httpParams = new BasicHttpParams();
                setConnectionTimeout(httpParams, 3000);
                setSoTimeout(httpParams, 5000);

                HttpProtocolParams.setVersion(httpParams, HttpVersion.HTTP_1_1);
                HttpProtocolParams.setContentCharset(httpParams, HTTP.UTF_8);

                SchemeRegistry registry = new SchemeRegistry();
                registry.register(new Scheme("http", PlainSocketFactory.getSocketFactory(), 80));
                registry.register(new Scheme("https", sf, 443));

                ClientConnectionManager ccm = new ThreadSafeClientConnManager(httpParams, registry);

                HttpClient httpclient = new DefaultHttpClient(ccm, httpParams);

                httpclient = new DefaultHttpClient(httpParams);

                response = httpclient.execute(httpGet);

                String ret = URLDecoder.decode(EntityUtils.toString(response.getEntity()), HTTP.UTF_8);

                if ( response != null && response.getStatusLine().getStatusCode() == 200 ) {

                    JSONArray ja = new JSONArray(ret);

                    if ( ja != null ){

                        int size = ja.length();
                        for ( int i = 0; i < size ; i++ ){

                            JSONObject jo = ja.getJSONObject(i);
                            Usuario u = new Usuario();
                            u.setId(Integer.parseInt(jo.getString("id")));
                            u.setNome(new String(jo.getString("nome").getBytes("ISO-8859-1"), HTTP.UTF_8));
                            u.setDtNasc(new String(jo.getString("data_nasc").getBytes("ISO-8859-1"), HTTP.UTF_8));

                            String sobre = new String(jo.getString("sobre").getBytes("ISO-8859-1"), HTTP.UTF_8);
                            if ( !sobre.isEmpty() && !sobre.equals("null") )
                                u.setSobre(sobre);

                            u.setLatitude(Double.parseDouble(jo.getString("latitude")));
                            u.setLongitude(Double.parseDouble(jo.getString("longitude")));
                            u.setCidade(new String(jo.getString("cidade").getBytes("ISO-8859-1"), HTTP.UTF_8));
                            u.setEstado(new String(jo.getString("estado").getBytes("ISO-8859-1"), HTTP.UTF_8));
                            u.setPais(new String(jo.getString("pais").getBytes("ISO-8859-1"), HTTP.UTF_8));
                            u.setImagem(new String(jo.getString("imagem").getBytes("ISO-8859-1"), HTTP.UTF_8).replace(" ", "+"));
                            u.setDist(Double.parseDouble(jo.getString("distancia")));

                            List<String> ls = new ArrayList<>();
                            String[] estilos = new String(jo.getString("estilos").getBytes("ISO-8859-1"), HTTP.UTF_8).split(",");
                            for ( String s : estilos ){
                                if ( !s.isEmpty() && !s.equals("null") )
                                    ls.add( s  );
                            }
                            u.setEstilos(ls);

                            ls = new ArrayList<>();
                            String[] influ = new String(jo.getString("influencias").getBytes("ISO-8859-1"), HTTP.UTF_8).split(",");
                            for ( String s : influ ) {
                                if ( !s.isEmpty() && !s.equals("null") )
                                    ls.add( s  );
                            }
                            u.setInfluencias(ls);

                            lUsers.add(u);
                        }
                    }
                }

                httpGet.abort();
                response.getEntity().consumeContent();
                httpclient.getConnectionManager().closeExpiredConnections();
                httpclient.getConnectionManager().shutdown();

            }
            catch (Exception e) {
                e.printStackTrace();
                exceptionToBeThrown = e;
            }

            return null;
        }

        @Override
        protected void onPostExecute(Void aVoid) {
            super.onPostExecute(aVoid);

            if ( exceptionToBeThrown != null && !getActivity().isDestroyed() ){
                new FetchUserData().execute();
            }
            else{

                (v.findViewById(R.id.loading)).setVisibility(View.GONE);

                List<Usuario> lu = new ArrayList<>(new LinkedHashSet<>(lUsers));
                lUsers.clear();
                lUsers.addAll(lu);

                executando = false;

                if ( first ) {
                    first = false;
                    if (lUsers.isEmpty()) {
                        (v.findViewById(R.id.imgError)).setVisibility(View.VISIBLE);
                    }
                }

                ulad.notifyDataSetChanged();

            }
        }
    }
}
