package tads.ufpr.pr.br.backstage;

import android.app.FragmentManager;
import android.app.FragmentTransaction;
import android.os.Bundle;
import android.support.v4.content.ContextCompat;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.view.MenuItem;

public class SearchActivity extends AppCompatActivity {

    Usuario u;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_search);

        u = ((AppController)this.getApplication()).getUsuario();

        initToolbar();

        FragmentManager fragmentManager = getFragmentManager();
        FragmentTransaction fragmentTransaction = fragmentManager.beginTransaction();
        fragmentTransaction.add(R.id.frag_search_container, new SearchFilterFragment(), "SearchFilter");
        fragmentTransaction.commit();

    }

    private void initToolbar() {
        Toolbar mToolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(mToolbar);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        setTitle(getString(R.string.filter));
        mToolbar.setTitleTextColor(ContextCompat.getColor(this, R.color.white));
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        finish();
        return super.onOptionsItemSelected(item);
    }

    @Override
    protected void onSaveInstanceState(Bundle outState){
        super.onSaveInstanceState(outState);
        outState.putSerializable("usuario", u);
    }

    @Override
    protected void onRestoreInstanceState(Bundle savedInstanceState) {
        super.onRestoreInstanceState(savedInstanceState);

        u = (Usuario)savedInstanceState.getSerializable("usuario");
        ((AppController)this.getApplication()).setUsuario(u);

    }

    @Override
    protected void onResume() {
        super.onResume();
        if ( ((AppController) this.getApplication()).getListInstType() == null ||
                ((AppController) this.getApplication()).getListInstType().isEmpty() )
            ((AppController) this.getApplication()).instantiateInstList(this);
    }
}
