package tads.ufpr.pr.br.backstage;

import android.app.ProgressDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Typeface;
import android.location.Location;
import android.location.LocationManager;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.provider.Settings;
import android.support.annotation.Nullable;
import android.support.v4.app.Fragment;
import android.support.v7.app.AlertDialog;
import android.text.Editable;
import android.text.TextWatcher;
import android.util.Base64;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import org.apache.http.HttpResponse;
import org.apache.http.HttpVersion;
import org.apache.http.NameValuePair;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.conn.ClientConnectionManager;
import org.apache.http.conn.scheme.PlainSocketFactory;
import org.apache.http.conn.scheme.Scheme;
import org.apache.http.conn.scheme.SchemeRegistry;
import org.apache.http.conn.ssl.SSLSocketFactory;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.impl.conn.tsccm.ThreadSafeClientConnManager;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.params.BasicHttpParams;
import org.apache.http.params.HttpProtocolParams;
import org.apache.http.protocol.HTTP;
import org.apache.http.util.EntityUtils;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.security.KeyStore;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.Locale;

import Util.AppLocationService;
import Util.DatabaseHandler;
import Util.LocationAddress;
import Util.MySSLSocketFactory;
import Util.Utils;
import butterknife.ButterKnife;
import butterknife.InjectView;

import static org.apache.http.params.HttpConnectionParams.*;

@SuppressWarnings("All")
public class SignUp extends Fragment {

    @InjectView(R.id.input_email)       EditText _emailText;
    @InjectView(R.id.input_name)        EditText _nameText;
    @InjectView(R.id.input_date)        EditText _birth;
    @InjectView(R.id.input_password)    EditText _passwordText;
    @InjectView(R.id.input_password2)   EditText _password2Text;
    @InjectView(R.id.btn_signup)        Button   _signupButton;

    Usuario u;
    ProgressDialog progressDialog;
    AppLocationService appLocationService;

    @Override
    public View onCreateView(LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {

        View v = inflater.inflate(R.layout.signup_fragment_layout, container, false);
        appLocationService = new AppLocationService(getActivity());
        Typeface tf = Typeface.createFromAsset(getActivity().getAssets(), "GeosansLight.ttf");
        ((TextView) v.findViewById(R.id.app_name)).setTypeface(tf);

        u = new Usuario();

        ButterKnife.inject(this, v);

        setHandleDate();

        _signupButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                signUp();
            }
        });

        return v;
    }

    private void setHandleDate() {

        _birth.addTextChangedListener(new TextWatcher() {

            private String current = "";
            private String ddmmyyyy = "DDMMYYYY";
            private Calendar cal = Calendar.getInstance();
            private Calendar cal2 = Calendar.getInstance();

            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {
                //Do Nothing
            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {

                if (!s.toString().equals(current)) {

                    String clean = s.toString().replaceAll("[^\\d.]", "");
                    String cleanC = current.replaceAll("[^\\d.]", "");

                    int cl = clean.length();
                    int sel = cl;
                    for (int i = 2; i <= cl && i < 6; i += 2) {
                        sel++;
                    }

                    if (clean.equals(cleanC)) sel--;

                    if (clean.length() < 8)
                        clean = clean + ddmmyyyy.substring(clean.length());

                    else {
                        int day = Integer.parseInt(clean.substring(0, 2));
                        int mon = Integer.parseInt(clean.substring(2, 4));
                        int year = Integer.parseInt(clean.substring(4, 8));

                        if (mon > 12) mon = 12;
                        cal.set(Calendar.MONTH, mon - 1);
                        int minYear = cal2.get(Calendar.YEAR) - 80;
                        int maxYear = cal2.get(Calendar.YEAR) - 6;
                        year = (year < minYear) ? minYear : (year > maxYear) ? maxYear : year;
                        cal.set(Calendar.YEAR, year);

                        day = (day > cal.getActualMaximum(Calendar.DATE)) ? cal.getActualMaximum(Calendar.DATE) : day;
                        clean = String.format("%02d%02d%02d", day, mon, year);
                    }

                    clean = String.format("%s/%s/%s", clean.substring(0, 2),
                            clean.substring(2, 4),
                            clean.substring(4, 8));

                    sel = sel < 0 ? 0 : sel;
                    current = clean;
                    _birth.setText(current);
                    _birth.setSelection(sel < current.length() ? sel : current.length());
                }
            }

            @Override
            public void afterTextChanged(Editable s) {
                //Do Nothing
            }
        });
    }

    private void signUp() {

        _signupButton.setEnabled(false);

        u.setNome(_nameText.getText().toString());
        u.setEmail(_emailText.getText().toString());
        u.setSenha(_passwordText.getText().toString());

        if (!validate()) {
            _signupButton.setEnabled(true);
            return;
        }
    }

    private boolean validate() {

        String password2 = _password2Text.getText().toString();

        if (u.getNome().isEmpty()) {
            _nameText.requestFocus();
            _nameText.setError(getResources().getString(R.string.no_name_error));
            return false;
        }

        if (u.getEmail().isEmpty() || !android.util.Patterns.EMAIL_ADDRESS.matcher(u.getEmail()).matches()) {
            _emailText.requestFocus();
            _emailText.setError(getResources().getString(R.string.wrong_email_error));
            return false;
        } else {
            _emailText.setError(null);
        }

        u.setDtNasc(_birth.getText().toString());
        if ( u.getDtNasc().isEmpty() || !isValidDate()) {
            _birth.requestFocus();
            _birth.setError(getResources().getString(R.string.no_date_error));
            return false;
        } else {
            _birth.setError(null);
        }

        if (u.getSenha().isEmpty() || u.getSenha().length() < 4) {
            _passwordText.requestFocus();
            _passwordText.setError(getResources().getString(R.string.few_chars_pass_error));
            return false;
        } else {
            _passwordText.setError(null);
        }

        if (password2.isEmpty() || !password2.equals(u.getSenha())) {
            _password2Text.requestFocus();
            _password2Text.setError(getResources().getString(R.string.unlike_password_error));
            return false;
        } else {
            _password2Text.setError(null);
        }

        if ( !Utils.isNetworkOnline(this.getContext()) ){
            //Sem Conexão com a Internet
            Utils.alertDialog(getActivity(), getResources().getString(R.string.no_network_title),
                    getResources().getString(R.string.no_network_text), 1);
            return false;
        }

        if ( u.getCidade()   == null || u.getCidade().isEmpty() ||
             u.getEstado()   == null || u.getEstado().isEmpty() ||
             u.getPais()     == null || u.getPais().isEmpty()   ||
             u.getLatitude() == 0    || u.getLongitude() == 0) {

            if (appLocationService.isLocationEnabled()) {

                progressDialog = new ProgressDialog(getActivity(), R.style.AppTheme_Dark_Dialog);
                progressDialog.setIndeterminate(true);
                progressDialog.setCancelable(false);
                progressDialog.setMessage(getResources().getString(R.string.getting_location));
                progressDialog.show();

                Location location = appLocationService.getLocation(getActivity(),
                        LocationManager.GPS_PROVIDER, LocationManager.NETWORK_PROVIDER);

                if (location != null) {

                    double latitude = location.getLatitude();
                    double longitude = location.getLongitude();

                    u.setLatitude(latitude);
                    u.setLongitude(longitude);

                    LocationAddress locationAddress = new LocationAddress();
                    LocationAddress.getAddressFromLocation(latitude, longitude,
                            getActivity().getApplicationContext(), new GeocoderHandler());

                } else {
                    progressDialog.dismiss();
                    progressDialog.cancel();
                    return false;
                }

            } else {
                showSettingsAlert();
                return false;
            }
        }
        else{

            new doSignUp().execute();

        }

        return true;
    }

    public void showSettingsAlert() {

        AlertDialog.Builder alertDialog = new AlertDialog.Builder(getActivity());

        alertDialog.setTitle(getString(R.string.settings));
        alertDialog.setMessage(getString(R.string.enable_location));

        alertDialog.setPositiveButton(getString(R.string.settings), new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog, int which) {

                dialog.cancel();
                dialog.dismiss();

                Intent callGPSSettingIntent = new Intent(android.provider.Settings.ACTION_LOCATION_SOURCE_SETTINGS);
                startActivityForResult(callGPSSettingIntent, 1);

                //Intent intent = new Intent(Settings.ACTION_LOCATION_SOURCE_SETTINGS);
                //getActivity().startActivity(intent);

            }
        });

        alertDialog.show();
    }

    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if ( requestCode == 1 )
            signUp();

    }

    private boolean isValidDate() {

        try {

            DateFormat df = new SimpleDateFormat("dd/MM/yyyy");
            df.setLenient(false);
            df.parse(u.getDtNasc().toString());
            return true;

        } catch (Exception e) {
            return false;
        }
    }

    private class GeocoderHandler extends Handler {

        @Override
        public void handleMessage(Message message) {

            progressDialog.cancel();
            progressDialog.dismiss();

            Bundle bundle = message.getData();

            switch (message.what) {

                case 10:

                    u.setCidade(bundle.getString("city"));
                    u.setEstado(bundle.getString("state"));
                    u.setPais(bundle.getString("country"));

                    new doSignUp().execute();

                    break;

                case 11:

                    _signupButton.setEnabled(true);

                    Utils.alertDialog(getActivity(), getResources().getString(R.string.signup_error),
                            "Erro ao recuperar localização", 1);

                    break;
            }
        }
    }

    private class doSignUp extends AsyncTask<Void, Void, Void> {

        HttpResponse response;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

            progressDialog = new ProgressDialog(getActivity(), R.style.AppTheme_Dark_Dialog);
            progressDialog.setIndeterminate(true);
            progressDialog.setCancelable(false);
            progressDialog.setTitle(getResources().getString(R.string.authenticating));
            progressDialog.setMessage(getResources().getString(R.string.wait_signup));
            progressDialog.show();

        }

        @Override
        protected void onPostExecute(Void aVoid) {
            super.onPostExecute(aVoid);

            progressDialog.dismiss();
            progressDialog.cancel();
            _signupButton.setEnabled(true);

            if ( response != null ) {

                if ( response.getStatusLine().getStatusCode() == 201 ) {

                    String ret;

                    try {

                        ret = EntityUtils.toString(response.getEntity());
                        JSONArray ja = new JSONArray(ret);

                        response.getEntity().consumeContent();

                        if ( ja != null ){

                            JSONObject jo = ja.getJSONObject(0);
                            u.setId(Integer.parseInt(jo.getString("id")));

                            if ( u.getId() != 0 ){

                                DatabaseHandler db = new DatabaseHandler(getActivity());
                                db.addUser(u);

                                ((AppController) getActivity().getApplication()).setUsuario(u);
                                ((AppController)getActivity().getApplication()).instantiateInstList(getActivity());

                                //Intent iservice = new Intent(getActivity(), GetMessages.class);
                                //getActivity().startService(iservice);

                                Intent i = new Intent(getActivity(), MainActivity.class);
                                startActivity(i);
                                getActivity().finish();

                            }
                        }

                    }
                    catch (IOException e)   { e.printStackTrace(); }
                    catch (JSONException e) { e.printStackTrace(); }
                }

                else  {

                    _signupButton.setEnabled(true);

                    Utils.alertDialog(getActivity(), getResources().getString(R.string.signup_error),
                            getResources().getString(R.string.duplicate_email_error), 1);

                }
            }
            else {

                _signupButton.setEnabled(true);

                Utils.alertDialog(getActivity(), getResources().getString(R.string.signup_error),
                        getResources().getString(R.string.generic_error), 1);

            }
        }


        @Override
        protected Void doInBackground(Void... params) {

            try{

                KeyStore trustStore = KeyStore.getInstance(KeyStore.getDefaultType());
                trustStore.load(null, null);

                MySSLSocketFactory sf = new MySSLSocketFactory(trustStore);
                sf.setHostnameVerifier(SSLSocketFactory.ALLOW_ALL_HOSTNAME_VERIFIER);

                BasicHttpParams httpParams = new BasicHttpParams();
                setConnectionTimeout(httpParams, 3000);
                setSoTimeout(httpParams, 5000);

                HttpProtocolParams.setVersion(httpParams, HttpVersion.HTTP_1_1);
                HttpProtocolParams.setContentCharset(httpParams, HTTP.UTF_8);

                SchemeRegistry registry = new SchemeRegistry();
                registry.register(new Scheme("http", PlainSocketFactory.getSocketFactory(), 80));
                registry.register(new Scheme("https", sf, 443));

                ClientConnectionManager ccm = new ThreadSafeClientConnManager(httpParams, registry);

                HttpClient httpclient = new DefaultHttpClient(ccm, httpParams);

                httpclient = new DefaultHttpClient(httpParams);

                String url = getString( R.string.server_address ) + "/usuario";

                HttpPost httppost = new HttpPost(url);

                List<NameValuePair> lp = new ArrayList<>();
                lp.add(new BasicNameValuePair("mail", u.getEmail()));

                String md5 = Utils.getMd5Hash(u.getSenha());

                lp.add(new BasicNameValuePair("pass", md5));
                lp.add(new BasicNameValuePair("name", u.getNome()));

                DateFormat df = new SimpleDateFormat("dd/MM/yyyy");
                df.setLenient(false);
                Date date = df.parse(u.getDtNasc().toString());
                df = new SimpleDateFormat("yyyy-MM-dd", Locale.US);
                lp.add(new BasicNameValuePair("birth", df.format(date)));
                u.setDtNasc(df.format(date).toString());

                lp.add(new BasicNameValuePair("lat", String.valueOf(u.getLatitude())));
                lp.add(new BasicNameValuePair("long", String.valueOf(u.getLongitude())));
                lp.add(new BasicNameValuePair("city", u.getCidade()));
                lp.add(new BasicNameValuePair("state", u.getEstado()));
                lp.add(new BasicNameValuePair("country", u.getPais()));

                UrlEncodedFormEntity urle = new UrlEncodedFormEntity(lp, HTTP.UTF_8);
                urle.setContentType("application/x-www-form-urlencoded");
                urle.setContentEncoding(HTTP.UTF_8);

                String user = getResources().getString(R.string.server_user);
                String basicAuth = "Basic " + Base64.encodeToString(user.getBytes(), Base64.NO_WRAP);
                httppost.setHeader("Authorization", basicAuth);

                httppost.setHeader(HTTP.CONTENT_TYPE, "application/x-www-form-urlencoded; charset=UTF-8");
                httppost.setEntity(urle);
                response = httpclient.execute(httppost);

                httppost.abort();

            }
            catch (UnsupportedEncodingException e) { e.printStackTrace(); }
            catch (Exception e) { e.printStackTrace(); }

            return null;
        }
    }
}