package tads.ufpr.pr.br.backstage;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;
import android.os.AsyncTask;
import android.support.v7.widget.RecyclerView;
import android.util.Base64;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

import org.apache.http.HttpResponse;
import org.apache.http.HttpVersion;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.conn.ClientConnectionManager;
import org.apache.http.conn.scheme.PlainSocketFactory;
import org.apache.http.conn.scheme.Scheme;
import org.apache.http.conn.scheme.SchemeRegistry;
import org.apache.http.conn.ssl.SSLSocketFactory;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.impl.conn.tsccm.ThreadSafeClientConnManager;
import org.apache.http.params.BasicHttpParams;
import org.apache.http.params.HttpProtocolParams;
import org.apache.http.protocol.HTTP;
import org.apache.http.util.EntityUtils;
import org.json.JSONArray;
import org.json.JSONObject;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.security.KeyStore;
import java.util.ArrayList;
import java.util.List;

import Util.MySSLSocketFactory;
import Util.RoundImage;
import Util.Utils;

import static org.apache.http.params.HttpConnectionParams.setConnectionTimeout;
import static org.apache.http.params.HttpConnectionParams.setSoTimeout;

@SuppressWarnings("All")
public class UsersListAdapter extends RecyclerView.Adapter<UsersListAdapter.UsersListViewHolder> {

    Usuario me;
    Usuario u;
    Activity activity;
    List<Usuario> userList;
    UsersListViewHolder uvh;

    UsersListAdapter(List<Usuario> userList, Usuario usuario){
        this.userList = userList;
        this.me = usuario;
    }

    @Override
    public UsersListViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
        View v = LayoutInflater.from(parent.getContext()).inflate(R.layout.user_list_item, parent, false);
        uvh = new UsersListViewHolder(v);
        return uvh;
    }

    public void setActivity(Activity activity) {
        this.activity = activity;
    }

    @Override
    public void onBindViewHolder(UsersListViewHolder holder, final int position) {

        holder.tvName.setText(userList.get(position).getNome());

        if ( userList.get(position).getImagem() != null && !userList.get(position)
                .getImagem().isEmpty() && !userList.get(position).getImagem().equals("null") ) {

            Bitmap bm = Utils.string2Bitmap(userList.get(position).getImagem());
            RoundImage rm = new RoundImage(bm);
            holder.ivUserImage.setImageDrawable(rm);
        }
        else{
            holder.ivUserImage.setImageResource(R.drawable.aboutme);
        }

        if ( activity.getClass() == MainActivity.class || activity.getClass() == MessagesActivity.class ){

            if ( userList.get(position).getCidade() != null && !userList.get(position).getCidade().isEmpty() )
                holder.tvDist.setText(userList.get(position).getCidade());

        }
        else {

            if ( userList.get(position) != null && userList.get(position).getLatitude() != 0 &&
                    userList.get(position).getLongitude() != 0 && me != null &&
                    me.getLongitude() != 0 && me.getLatitude() != 0 ){

                double dist = userList.get(position).getDist();

                //holder.tvDist.setText(String.format("%1$,.3f", dist) + " " +  );
                dist = dist / 1000;
                if ( dist >= 1 ) {
                    String s = String.format("%1$.1f", dist);
                    s = s.replace(",", ".");
                    double d = Double.parseDouble(s);
                    if (d % 1 != 0)
                        holder.tvDist.setText(String.format("%1$,.1f", dist) + " " + activity.getString(R.string.km));
                    else {
                        int i = (int) d;
                        holder.tvDist.setText(i + " " + activity.getString(R.string.km));
                    }
                }
                else if ( dist > 0 ) {
                    String s = String.format("%1$.3f", dist);
                    s = s.replace(",", ".");
                    double d = Double.parseDouble(s);
                    if (d % 1 == 0)
                        holder.tvDist.setText(activity.getString(R.string.same_location));
                    else {
                        int i = Integer.parseInt(s.substring(2, 4));
                        if ( i == 0 )
                            holder.tvDist.setText(activity.getString(R.string.same_location));
                        else if ( i == 1 )
                            holder.tvDist.setText(i + " metro");
                        else
                            holder.tvDist.setText(i + " " + activity.getString(R.string.meters));
                    }
                }
                else
                    holder.tvDist.setText(activity.getString(R.string.same_location));

            }
            else{
                holder.tvDist.setText(R.string.no_dist_calc);
            }

        }

        holder.itemView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                if ( activity.getClass() != MessagesActivity.class ){

                    u = userList.get(position);
                    GetUserData gut = new GetUserData(v.getContext(), u.getId());
                    gut.execute();

                }
                else {

                    u = userList.get(position);
                    Intent i = new Intent(activity, ChatActivity.class);
                    i.putExtra("person", u);
                    activity.startActivity(i);

                }
            }
        });

    }

    @Override
    public void onAttachedToRecyclerView(RecyclerView recyclerView) {
        super.onAttachedToRecyclerView(recyclerView);
    }

    @Override
    public int getItemCount() {
        return userList.size();
    }

    public class UsersListViewHolder extends RecyclerView.ViewHolder {

        ImageView ivUserImage;
        ImageView ivIsFriend;
        TextView  tvName;
        TextView  tvDist;

        public UsersListViewHolder(View itemView) {
            super(itemView);

            ivUserImage = (ImageView)itemView.findViewById(R.id.iv_user_image);
            ivIsFriend  = (ImageView)itemView.findViewById(R.id.iv_is_friend);
            tvName = (TextView)itemView.findViewById(R.id.tv_userName);
            tvDist = (TextView)itemView.findViewById(R.id.tv_userDist);

        }
    }

    private class GetUserData extends AsyncTask<Void, Void, Void>{

        int userId;
        Context context;
        HttpResponse response;
        ProgressDialog progressDialog;

        public GetUserData ( Context context, int userId ){
            this.context = context;
            this.userId  = userId;
        }

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

            progressDialog = new ProgressDialog(context, R.style.AppTheme_Dark_Dialog);
            progressDialog.setIndeterminate(true);
            progressDialog.setCancelable(false);
            progressDialog.setMessage("Recuperando as informações de " + u.getNome() + "..." );
            progressDialog.show();

        }

        @Override
        protected void onPostExecute(Void aVoid) {
            super.onPostExecute(aVoid);

            progressDialog.dismiss();
            progressDialog.cancel();

            Intent i = new Intent(activity, ProfileActivity.class);
            i.putExtra("user", u);
            activity.startActivity(i);

        }

        @Override
        protected Void doInBackground(Void... params) {

            try{

                KeyStore trustStore = KeyStore.getInstance(KeyStore.getDefaultType());
                trustStore.load(null, null);

                MySSLSocketFactory sf = new MySSLSocketFactory(trustStore);
                sf.setHostnameVerifier(SSLSocketFactory.ALLOW_ALL_HOSTNAME_VERIFIER);

                BasicHttpParams httpParams = new BasicHttpParams();
                setConnectionTimeout(httpParams, 3000);
                setSoTimeout(httpParams, 5000);

                HttpProtocolParams.setVersion(httpParams, HttpVersion.HTTP_1_1);
                HttpProtocolParams.setContentCharset(httpParams, HTTP.UTF_8);

                SchemeRegistry registry = new SchemeRegistry();
                registry.register(new Scheme("http", PlainSocketFactory.getSocketFactory(), 80));
                registry.register(new Scheme("https", sf, 443));

                ClientConnectionManager ccm = new ThreadSafeClientConnManager(httpParams, registry);

                HttpClient httpclient = new DefaultHttpClient(ccm, httpParams);

                httpclient = new DefaultHttpClient(httpParams);

                String url = activity.getString( R.string.server_address )
                        + "/usuario/" + u.getId() + "/instrumentos" ;
                HttpGet httpGet = new HttpGet(url);

                String user = activity.getString(R.string.server_user);
                String basicAuth = "Basic " + Base64.encodeToString(user.getBytes(), Base64.NO_WRAP);
                httpGet.setHeader("Authorization", basicAuth);

                response = httpclient.execute(httpGet);

                if ( response != null && response.getStatusLine().getStatusCode() == 200 ) {

                    String ret = URLDecoder.decode(EntityUtils.toString(response.getEntity()), HTTP.UTF_8);

                    if ( !ret.isEmpty() ){

                        JSONArray ja = new JSONArray(ret);

                        if ( ja != null ){

                            List<Instrumento> lInst = new ArrayList<>();

                            for ( int i = 0 ; i < ja.length() ; i++ ){

                                JSONObject jo = ja.getJSONObject(i);
                                Instrumento instrumento = new Instrumento();
                                instrumento.setInstId(jo.getInt("id"));
                                instrumento.setInstName(new String(jo.getString("nome").getBytes("ISO-8859-1"), HTTP.UTF_8));
                                instrumento.setInstType(jo.getInt("tipo_instrumento_id"));
                                instrumento.setInstLevel(jo.getInt("nivel"));

                                lInst.add(instrumento);

                            }

                            u.setInstrumentos(lInst);

                        }
                    }
                }

                response.getEntity().consumeContent();
                httpGet.abort();
                httpclient.getConnectionManager().closeExpiredConnections();
                httpclient.getConnectionManager().shutdown();

            }
            catch (UnsupportedEncodingException e1) { e1.printStackTrace(); }
            catch (ClientProtocolException e1) { e1.printStackTrace(); }
            catch (IOException e1) { e1.printStackTrace(); }
            catch (Exception e) { e.printStackTrace(); }

            return null;
        }
    }
}
